/*!Amalia.js V1.2.3, © INA 2015 */
/**
 * Copyright (c) 2015 Institut National de l'Audiovisuel, INA
 * This file is part of amalia.js

 * amalia.js is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or (at your option) any later version.

 * Redistributions of source code, javascript and css minified versions
 * must retain the above copyright notice, this list of conditions and the following disclaimer.

 * Neither the name of the copyright holder nor the names of its
 * contributors may be used to endorse or promote products derived from
 * this software without specific prior written permission.

 * You should have received a copy of the GNU General Public License
 * along with amalia.js. If not, see <http://www.gnu.org/licenses/>

 *
 * amalia.js is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
 * GNU General Public License for more details.
 */

$.Class("fr.ina.amalia.player.log.LogHandler",{},{settings:{},init:function(a){this.settings=$.extend({enabled:!1},a||{})},trace:function(a,b){var c=null;return this.settings.enabled&&window.console&&window.console.info&&a&&b&&(c=a+":"+b,console.info(c)),c},info:function(a){var b=a?a:null;return this.settings.enabled&&window.console&&window.console.debug&&console.debug(b),b},error:function(a){var b=a?a:null;return this.settings.enabled&&window.console&&window.console.error&&console.error(b),b},warn:function(a){var b=a?a:null;return this.settings.enabled&&window.console&&window.console.warn&&console.warn(b),b}}),$.Class("fr.ina.amalia.player.helpers.BrowserFeatureDetection",{isMobilePlatform:function(){return navigator.userAgent.match(/(iPod|iPhone|iPad)/)||navigator.userAgent.toLowerCase().indexOf("android")>-1}},{settings:{},logger:null,init:function(a){this.settings=$.extend({debug:!1},a||{}),void 0!==fr.ina.amalia.player.log&&void 0!==fr.ina.amalia.player.log.LogHandler&&(this.logger=new fr.ina.amalia.player.log.LogHandler({enabled:this.settings.debug}))},isSupportsVideos:function(){return document.createElement("video").canPlayType?(null!==this.logger&&this.logger.info("Support html5"),!0):(null!==this.logger&&this.logger.info("Can't support html5"),!1)},isSupportsMp4:function(){if(this.isSupportsVideos()){var a=document.createElement("video");return a.canPlayType("video/mp4")?(null!==this.logger&&this.logger.info("Support mp4"),!0):(null!==this.logger&&this.logger.info("Can't support mp4"),!1)}return!1}}),$.Class("fr.ina.amalia.player.helpers.HTML5Helper",{isFullScreen:function(){var a=$(document).context;return a.fullscreen||a.mozFullScreen||a.webkitIsFullScreen},toggleFullScreen:function(a,b){var c=$(document).context,d=c.fullscreen||c.mozFullScreen||c.webkitIsFullScreen?!0:!1;if(d===!1||b===!0){var e=a.requestFullScreen||a.webkitRequestFullScreen||a.mozRequestFullScreen||a.msRequestFullscreen||a.webkitEnterFullscreen;if("undefined"!=typeof e&&e)return e.call(a),!0}else{var f=document.cancelFullScreen||document.mozCancelFullScreen||document.webkitCancelFullScreen;if("undefined"!=typeof f&&f)return f.call(document),!1}}},{}),$.Class("fr.ina.amalia.player.helpers.UtilitiesHelper",{formatTime:function(a,b,c){var d=d||"f",e=b||25,f=Math.floor(Math.floor(1e5*(a-Math.floor(a)))*e/1e5),g=Math.floor(a/60),h=Math.floor(g/60),i=a%60;switch(a=Math.floor(a%60),g=Math.floor(g%60),g=g>=10?g:"0"+g,h=h>=10?h:"0"+h,a=a>=10?a:"0"+a,f=f>=10?f:"0"+f,c){case"h":d=h;break;case"m":d=h+":"+g;break;case"s":d=h+":"+g+":"+a;break;case"mms":d=h+":"+g+":"+a+"."+i.toFixed(4).split(".")[1];break;case"ms":d=h+":"+g+":"+a+"."+i.toFixed(2).split(".")[1];break;case"f":d=h+":"+g+":"+a+":"+f;break;case"f_imp":d=h+":"+g+":"+a+"."+f;break;default:d=h+":"+g+":"+a+":"+i.toFixed(2).split(".")[1]}return d},getTimeRange:function(a,b,c){var d=[],e=c||25,f="undefined"==typeof b?"1":b;a=Math.floor(a);for(var g=0;a>=g;g+=f)if("f"===b){g=Math.floor(g);for(var h=0;e>h;h++)g+=1e3/e/1e3,d.push(fr.ina.amalia.player.helpers.UtilitiesHelper.formatTime(g,c))}else d.push(fr.ina.amalia.player.helpers.UtilitiesHelper.formatTime(g,c));return d},getRangesWithStartAndEndTime:function(a,b,c){for(var d=[],e="undefined"==typeof c?"1":c,f=a;b>=f;f+=e)d.push(f);return d},convertHourToSeconde:function(a){var b=null,c=/\d{2}:\d{2}:\d{2}/,d=c.exec(a);if(null!==d){d=a.split(":");var e=Math.floor(d[0]),f=Math.floor(d[1]),g=parseFloat(d[2]);b=60*e*60+60*f+g}return b},uint6ToB64:function(a){return 26>a?a+65:52>a?a+71:62>a?a-4:62===a?43:63===a?47:65},b64ToUint6:function(a){return a>64&&91>a?a-65:a>96&&123>a?a-71:a>47&&58>a?a+4:43===a?62:47===a?63:0},base64DecToArr:function(a,b){for(var c,d,e=a.replace(/[^A-Za-z0-9\+\/]/g,""),f=e.length,g=b?Math.ceil((3*f+1>>2)/b)*b:3*f+1>>2,h=new Uint8Array(g),i=0,j=0,k=0;f>k;k++)if(d=3&k,i|=fr.ina.amalia.player.helpers.UtilitiesHelper.b64ToUint6(e.charCodeAt(k))<<18-6*d,3===d||f-k===1){for(c=0;3>c&&g>j;c++,j++)h[j]=i>>>(16>>>c&24)&255;i=0}return h}},{}),$.Class("fr.ina.amalia.player.PlayerErrorCode",{ACCESS_DENIED:1001,MEDIA_FILE_NOT_FOUND:2001,CUSTOM_ERROR:3001,EXCEPTION:4001,HTTP_ERROR:5001,ABORT:6001,TIMEOUT:7008,ERROR:8008,ERROR_HTML5_SUPPORT:8e3,ERROR_LOAD_PLUGIN:9001,getMessage:function(a){var b=fr.ina.amalia.player.PlayerErrorCode,c=fr.ina.amalia.player.PlayerErrorMessage;switch(a){case b.ACCESS_DENIED:return c.ACCESS_DENIED;case b.MEDIA_FILE_NOT_FOUND:return c.MEDIA_FILE_NOT_FOUND;case b.EXCEPTION:return c.EXCEPTION;case b.HTTP_ERROR:return c.HTTP_ERROR;case b.ABORT:return c.ABORT;case b.TIMEOUT:return c.TIMEOUT;case b.ERROR_LOAD_PLUGIN:return c.ERROR_LOAD_PLUGIN;case b.CUSTOM_ERROR:return c.CUSTOM_ERROR;case b.ERROR:return c.ERROR;case b.ERROR_HTML5_SUPPORT:return c.ERROR_HTML5_SUPPORT;default:return c.DEFAULT}}},{}),$.Class("fr.ina.amalia.player.PlayerErrorMessage",{ACCESS_DENIED:"Accès refusé.",MEDIA_FILE_NOT_FOUND:"Erreur lors du chargement du média.",EXCEPTION:"An exception occurred.",HTTP_ERROR:"Http response at 400 or 500 level.",ABORT:"Votre requête a été interrompue.",TIMEOUT:"Demande dépassé.",ERROR_LOAD_PLUGIN:"Erreur inattendue lors de l'initialisation du plug-in.",CUSTOM_ERROR:"Une erreur s'est produite sur votre lecteur.",ERROR:"Une erreur s'est produite sur votre lecteur.",DEFAULT:"Une erreur s'est produite sur votre lecteur.",ERROR_HTML5_SUPPORT:"Une erreur s'est produite sur votre lecteur: Votre navigateur ne gère pas les balises HTML5."},{}),$.Class("fr.ina.amalia.player.PlayerEventType",{STARTED:"fr.ina.amalia.player.PlayerEventType.STARTED",PLAYING:"fr.ina.amalia.player.PlayerEventType.PLAYING",PAUSED:"fr.ina.amalia.player.PlayerEventType.PAUSED",ENDEN:"fr.ina.amalia.player.PlayerEventType.ENDEN",MUTE:"fr.ina.amalia.player.PlayerEventType.MUTE",UN_MUTE:"fr.ina.amalia.player.PlayerEventType.UN_MUTE",VOLUME_CHANGE:"fr.ina.amalia.player.PlayerEventType.VOLUME_CHANGE",TIME_CHANGE:"fr.ina.amalia.player.PlayerEventType.TIME_CHANGE",FULLSCREEN_CHANGE:"fr.ina.amalia.player.PlayerEventType.FULLSCREEN_CHANGE",SEEK:"fr.ina.amalia.player.PlayerEventType.SEEK",ERROR:"fr.ina.amalia.player.PlayerEventType.ERROR",PLUGIN_READY:"fr.ina.amalia.player.PlayerEventType.PLUGIN_READY",PLUGIN_ERROR:"fr.ina.amalia.player.PlayerEventType.PLUGIN_ERROR",DATA_CHANGE:"fr.ina.amalia.player.PlayerEventType.DATA_CHANGE",IMAGE_CAPTURE:"fr.ina.amalia.player.PlayerEventType.IMAGE_CAPTURE",ZOOM_RANGE_CHANGE:"fr.ina.amalia.player.PlayerEventType.ZOOM_RANGE_CHANGE"},{}),$.Class("fr.ina.amalia.player.PlayerMessage",{PLAYER_OPENSOURCE_LINK:"Disponible en open source.",PLUGIN_OVERLAY_CONTEXT_MENU_ENABLED_DISABLED_PLUGIN:"Activer/désactiver le plugin overlay.",PLUGIN_TIMELINE_LABEL_ELEMENTS:"éléments.",PLUGIN_TIMELINE_LABEL_ZOOM_IN:"Zoom avant",PLUGIN_TIMELINE_LABEL_ZOOM_OUT:"Zoom arrière",PLUGIN_TIMELINE_LABEL_CHANGE_DISPLAY:"Changer la hauteur des lignes.",PLUGIN_TIMELINE_LABEL_SLIDE_LEFT:"Faire défiler vers la gauche",PLUGIN_TIMELINE_LABEL_SLIDE_RIGHT:"Faire défiler vers la droit",PLUGIN_TIMELINE_LABEL_SCROLL_UP:"Faire défiler vers le haut",PLUGIN_TIMELINE_LABEL_SCROLL_DOWN:"Faire défiler vers le bas",PLUGIN_TIMELINE_LABEL_SHOW_HIDE_TOOTIP:"Activer/désactiver les infobulles",PLUGIN_TIMELINE_LABEL_EXPAND:"Maximiser",PLUGIN_TIMELINE_LABEL_SORT:"Trier",PLUGIN_TIMELINE_LABEL_NAV_POINT_PREV:"Aller au marqueur précédent",PLUGIN_TIMELINE_LABEL_NAV_POINT_NEXT:"Aller au marqueur suivant",PLUGIN_TIMELINE_LABEL_TIMEAXE:"Axe temporel",PLUGIN_TIMELINE_LABEL_FOCUS:"Zoom",PLUGIN_TIMELINE_LABEL_CLOSE:"Fermer"},{}),$.Class("fr.ina.amalia.player.LoaderBase",{},{settings:{},logger:null,requestType:"GET",dataType:"json",sendData:{},timeout:12e4,data:null,handlerData:{},completeHandler:null,init:function(a,b,c){this.settings=$.extend({debug:!1},a||{}),this.handlerData=$.extend({debug:!1},c||{}),this.completeHandler=b,"undefined"!=typeof fr.ina.amalia.player.log&&"undefined"!=typeof fr.ina.amalia.player.log.LogHandler&&(this.logger=new fr.ina.amalia.player.log.LogHandler({enabled:this.settings.debug})),this.initialize()},initialize:function(){null!==this.logger&&this.logger.trace(this.Class.fullName,"initialize")},setRequestType:function(a){this.requestType=a},setDataType:function(a){this.dataType=a},setTimeout:function(a){this.timeout=a},setSendData:function(a){this.sendData=$.extend(this.sendData,a||{})},getSendData:function(){return this.sendData},getData:function(){return this.data},processFilterData:function(a){if(null!==a&&"undefined"!=typeof a){if(a.hasOwnProperty("status")===!0&&a.hasOwnProperty("data")===!0&&0===a.status&&null!==a)return a.data;if(a.hasOwnProperty("id")===!0)return a;null!==this.logger&&(this.logger.warn(this.Class.fullName,"Error while filtering Data."),this.logger.warn(a))}return null},load:function(a){var b=this;$.ajax({type:this.requestType,url:a,timeout:this.timeout,data:this.sendData,dataType:this.dataType,success:function(a,c){b.onSuccess(a,c)},error:function(a,c){b.onError(c)}})},onSuccess:function(a,b){null!==this.logger&&this.logger.trace(this.Class.fullName,"onSuccess status: "+b),this.data=this.processFilterData(a),"function"==typeof this.completeHandler&&this.completeHandler(this.handlerData,b)},onError:function(a){null!==this.logger&&this.logger.trace(this.Class.fullName,"onError status :"+a),this.data=null,"function"==typeof this.completeHandler&&this.completeHandler(this.handlerData,a)}}),$.Class("fr.ina.amalia.player.MediaFactory",{},{settings:{},logger:null,mediaContainer:null,player:null,errorContainer:null,init:function(a,b){this.mediaContainer=$(a),this.settings=$.extend({src:null,poster:"",autoplay:!1,plugins:{},callbacks:{},debug:!1},b||{}),void 0!==fr.ina.amalia.player.log&&void 0!==fr.ina.amalia.player.log.LogHandler&&(this.logger=new fr.ina.amalia.player.log.LogHandler({enabled:this.settings.debug})),this.initialize()},initialize:function(){try{this.loadPlayer(),null!==this.logger&&this.logger.trace(this.Class.fullName,"initialize")}catch(a){this.createErrorContainer(),this.setErrorCode(8e3),null!==this.logger&&this.logger.error(a.stack)}},createErrorContainer:function(){this.errorContainer=$("<div>",{"class":"inaplayer-error"}),this.errorContainer.hide(),this.mediaContainer.append(this.errorContainer)},setErrorCode:function(a){if("undefined"!=typeof this.errorContainer){var b=$("<p>",{text:fr.ina.amalia.player.PlayerErrorCode.getMessage(a)});this.errorContainer.html(b),this.errorContainer.show()}},loadPlayer:function(){if(null!==this.logger&&this.logger.trace(this.Class.fullName,"Load html 5 media player"),null===this.src)throw new Error("Can't find media src");var a=new fr.ina.amalia.player.helpers.BrowserFeatureDetection;if(!a.isSupportsVideos())throw null!==this.logger&&this.logger.error("Your browser does not support the video tag."),new Error("Your browser does not support the video tag.");this.loadHtml5MediaPlayer()},loadHtml5MediaPlayer:function(){null!==this.logger&&this.logger.info("Load html 5 media player"),this.player=new fr.ina.amalia.player.PlayerHtml5(this.settings,this.mediaContainer)},getPlayer:function(){return this.player}}),$.Class("fr.ina.amalia.player.plugins.PluginBase",{classCss:"plugin-default",style:""},{pluginContainer:null,mediaPlayer:null,logger:null,loaderContainer:null,settings:{},eventTag:"",init:function(a,b,c){if(this.mediaPlayer=b,this.pluginContainer=$(c),this.namespace=this.Class.fullName,this.settings=$.extend({debug:!1,internalPlugin:!1},a||{}),this.eventTag=this.Class.fullName+"_"+this.pluginContainer.attr("id"),this.settings.internalPlugin===!1&&(this.pluginContainer.addClass(this.Class.classCss),this.createLoader(),this.loaderContainer.show()),void 0!==fr.ina.amalia.player.log&&void 0!==fr.ina.amalia.player.log.LogHandler&&(this.logger=new fr.ina.amalia.player.log.LogHandler({enabled:this.settings.debug})),null===this.mediaPlayer)throw new Error("Can't initialize plugin name"+this.Class.fullName);try{if(this.settings.internalPlugin===!1){var d=this.mediaPlayer.getMediaPlayer();d.on(fr.ina.amalia.player.PlayerEventType.PLUGIN_READY,{self:this},this.onPluginReady),d.on(fr.ina.amalia.player.PlayerEventType.PLUGIN_ERROR,{self:this},this.onPluginError)}else this.initialize()}catch(e){null!==this.logger&&this.logger.error(e.stack)}},initialize:function(){},initializeError:function(a){var b=fr.ina.amalia.player.PlayerErrorCode.getMessage(a),c=$("<div>",{"class":"inaplayer-error",style:"",text:b});this.pluginContainer.append(c)},createLoader:function(){this.loaderContainer=$("<div>",{"class":"loader fa fa-cog fa-spin",style:""}),this.loaderContainer.hide(),this.pluginContainer.append(this.loaderContainer)},onPluginReady:function(a){null!==a.data.self.logger&&a.data.self.logger.trace(a.data.self.Class.fullName,"onPluginReady"),null!==a.data.self&&(a.data.self.initialize(),null!==a.data.self.loaderContainer&&a.data.self.loaderContainer.hide())},onPluginError:function(a,b){if(null!==a.data.self.logger&&a.data.self.logger.warn("PluginBase/onPluginError"),null!==a.data.self){var c="undefined"==typeof b.errorCode?"":b.errorCode;a.data.self.initializeError(c),null!==a.data.self.loaderContainer&&a.data.self.loaderContainer.hide()}}}),fr.ina.amalia.player.plugins.PluginBase.extend("fr.ina.amalia.player.plugins.captions.CaptionsBase",{},{container:null,listOfData:[],definePlayerListeners:function(){var a=this.mediaPlayer.getMediaPlayer();a.on(fr.ina.amalia.player.PlayerEventType.TIME_CHANGE,{self:this},this.onTimeupdate),null!==this.logger&&this.logger.trace(this.Class.fullName,"definePlayerListeners")},updateMetadata:function(a,b,c,d,e){var f=null,g=null;e=e||!1,g=this.mediaPlayer.getMetadataWithRange(a,c,d);for(var h=0;h<g.length;h++)f=g[h],f.hasOwnProperty("sublocalisations")===!0&&null!==f.sublocalisations?this._parseSubLocalisations(f.sublocalisations,b,e):null!==f?this._parseLocalisation(f,b,e):null!==this.logger&&this.logger.trace(this.Class.fullName,"Error to set data, index: "+h)},_parseLocalisation:function(a,b,c){var d=null;if(a.tclevel<=b){if(a.tclevel===b&&c===!1||a.tclevel<=b&&c===!0){var e=this._getText(a.data);""!==e&&(d={tcin:"number"==typeof a.tcin?a.tcin:fr.ina.amalia.player.helpers.UtilitiesHelper.convertHourToSeconde(a.tcin),tcout:"number"==typeof a.tcout?a.tcout:fr.ina.amalia.player.helpers.UtilitiesHelper.convertHourToSeconde(a.tcout),text:e,label:a.label,thumb:a.thumb,level:a.tclevel},this.listOfData.push(d))}a.hasOwnProperty("sublocalisations")===!0&&null!==a.sublocalisations&&a.sublocalisations.hasOwnProperty("localisation")===!0&&$.isArray(a.sublocalisations.localisation)&&this._parseSubLocalisations(a.sublocalisations,b,c)}},_parseSubLocalisations:function(a,b,c){var d=null;if(null!==a&&"undefined"!=typeof a&&a.hasOwnProperty("localisation")===!0&&$.isArray(a.localisation))for(var e=0;e<a.localisation.length;e++)d=a.localisation[e],this._parseLocalisation(d,b,c);return d},_getText:function(a){var b="";if(null!==a&&"undefined"!=typeof a&&a.hasOwnProperty("text")===!0&&null!==a.text&&$.isArray(a.text))for(var c=0;c<a.text.length;c++)null!==a.text[c]&&(b+=a.text[c].toString());return b},updatePos:function(a){null!==this.logger&&this.logger.trace(this.Class.fullName,"updatePos : "+a)},onTimeupdate:function(a,b){a.data.self.updatePos(parseFloat(b.currentTime))}}),$.Class("fr.ina.amalia.player.plugins.PluginManager",{},{settings:{},logger:null,pluginsSettings:{},plugins:null,mediaContainer:null,mediaPlayer:null,contextMenuPlugin:null,loadedCount:0,failCount:0,dataLoaded:0,init:function(a,b,c){this.mediaPlayer=b,this.mediaContainer=c,this.settings=$.extend({debug:!1},a||{}),this.pluginsSettings=$.extend({debug:this.settings.debug,dataServices:[],list:[]},a.plugins||{}),void 0!==fr.ina.amalia.player.log&&void 0!==fr.ina.amalia.player.log.LogHandler&&(this.logger=new fr.ina.amalia.player.log.LogHandler({enabled:this.settings.debug})),this.plugins=[],this.initialize()},initialize:function(){null!==this.logger&&this.logger.trace(this.Class.fullName,"initialize");var a={internalPlugin:!0};this.contextMenuPlugin=this.loadPlugin("fr.ina.amalia.player.plugins.ContextMenuPlugin",a,this.mediaPlayer,this.mediaContainer);var b=$.extend({internalPlugin:!0,framerate:this.settings.framerate,debug:this.settings.debug},this.settings.controlBar||{});this.loadPlugin(this.settings.controlBarClassName,b,this.mediaPlayer,this.mediaContainer),this.loadDynamicPlugins(this.pluginsSettings.list),this.mediaPlayer.mediaPlayer.one(fr.ina.amalia.player.PlayerEventType.STARTED,{self:this},this.onStarted),this.mediaPlayer.mediaPlayer.on(fr.ina.amalia.player.PlayerEventType.ERROR,{self:this},this.onError)},getContextMenuPlugin:function(){return this.contextMenuPlugin},onStarted:function(a){a.data.self.loadData(a.data.self.pluginsSettings.dataServices)},onError:function(a){a.data.self.mediaPlayer.mediaPlayer.trigger(fr.ina.amalia.player.PlayerEventType.PLUGIN_ERROR,{errorCode:fr.ina.amalia.player.PlayerErrorCode.ERROR_LOAD_PLUGIN})},loadData:function(a){if($.isArray(a)){var b=0,c=null,d={debug:this.settings.debug};for(b=0;b<a.length;++b)c=new fr.ina.amalia.player.LoaderBase(d,this.dataLoadedHandler,{self:this}),c.load(a[b])}else null!==this.logger&&this.logger.warn("Error dataServices is not array.")},dataLoadedHandler:function(a,b){"success"===b&&null!==this.getData()?(a.self.mediaPlayer.addMetadata(this.getData()),a.self.dataLoaded++,a.self.dataLoaded===a.self.pluginsSettings.dataServices.length&&a.self.mediaPlayer.mediaPlayer.trigger(fr.ina.amalia.player.PlayerEventType.PLUGIN_READY)):(null!==this.logger&&(this.logger.warn("Failed to load data. status: "+b),this.logger.warn(a)),a.self.mediaPlayer.mediaPlayer.trigger(fr.ina.amalia.player.PlayerEventType.PLUGIN_ERROR,{errorCode:fr.ina.amalia.player.PlayerErrorCode.ERROR_LOAD_PLUGIN}))},loadDynamicPlugins:function(a){null!==this.logger&&(this.logger.info(this.Class.fullName,"loadPlugins List : "),this.logger.info(a));for(var b in a){var c=a[b];if(c=$.extend({debug:this.pluginsSettings.debug,className:null,container:null,data:this.data,parameters:{}},c||{}),"object"==typeof c&&null!==c.className){var d=null===c.container?this.mediaContainer:$(c.container);c.internalPlugin=null===c.container,this.loadPlugin(c.className,c,this.mediaPlayer,d)}else null!==this.logger&&this.logger.warn(this.Class.fullName,"Error to load plugin className:"+c.className)}},loadPlugin:function(className,settings,mediaPlayer,pluginContainer){null!==this.logger&&this.logger.info(this.Class.fullName,"loadPlugin className:"+className);try{var obj=eval("new "+className+"(settings,mediaPlayer,pluginContainer)");return this.plugins.push(obj),this.loadedCount++,null!==this.logger&&this.logger.info(className+"Plugin loaded :  "+className),obj}catch(error){return this.failCount++,null!==this.logger&&(this.logger.warn("Error to load plugin : "+className),this.logger.warn(error.stack)),!1}}}),$.Class("fr.ina.amalia.player.plugins.controlBar.widgets.WidgetBase",{},{settings:{},logger:null,element:null,component:null,mediaPlayer:null,init:function(a,b,c){this.parameter=$.extend({debug:!0},a||{}),void 0!==fr.ina.amalia.player.log&&void 0!==fr.ina.amalia.player.log.LogHandler&&(this.logger=new fr.ina.amalia.player.log.LogHandler({enabled:this.parameter.debug})),this.container=c,this.mediaPlayer=b,this.initialize()},initialize:function(){},show:function(){this.component.show()},hide:function(){this.component.hide()}}),fr.ina.amalia.player.plugins.controlBar.widgets.WidgetBase.extend("fr.ina.amalia.player.plugins.controlBar.widgets.BaseButton",{classCss:"player-base-button",style:""},{initialize:function(){this.component=$("<div>",{"class":this.Class.classCss,style:this.Class.style});var a=$("<span>",{"class":"button-container"}),b=$("<span>",{"class":this.parameter.style});a.append(b),this.component.on("click",{self:this,component:this.component},this.onClick),this.component.append(a),this.container.append(this.component)},onClick:function(event){if("undefined"!=typeof event.data.self.parameter.callback)try{eval(event.data.self.parameter.callback+"(event.data.self.mediaPlayer, event.data.self.parameter)")}catch(e){null!==event.data.self.logger&&event.data.self.logger.warn("Send callback failed.")}}}),fr.ina.amalia.player.plugins.controlBar.widgets.WidgetBase.extend("fr.ina.amalia.player.plugins.controlBar.widgets.TimeLabel",{classCss:"player-timelabel time-display off",style:"",eventTypes:{}},{currentTime:null,timeSeparator:null,duration:null,initialize:function(){this.component=$("<div>",{"class":this.Class.classCss,style:this.Class.style}),this.currentTime=$("<span>",{"class":"time-current"}),this.timeSeparator=$("<span>",{"class":"time-separator"}),this.duration=$("<span>",{"class":"time-duration"}),this.component.append(this.currentTime),this.component.append(this.timeSeparator),this.component.append(this.duration),this.container.append(this.component),this.definePlayerEvents()},setCurrentTime:function(a){null!==this.currentTime&&this.currentTime.html(a)},setDuration:function(a){null!==this.duration&&(this.duration.html(a),this.component.removeClass("off").addClass("on"))},definePlayerEvents:function(){this.mediaPlayer.mediaContainer.on(fr.ina.amalia.player.PlayerEventType.TIME_CHANGE,{self:this},this.onTimechange)},onTimechange:function(a,b){var c=fr.ina.amalia.player.helpers.UtilitiesHelper.formatTime(b.currentTime,a.data.self.parameter.framerate,a.data.self.parameter.timeFormat),d=fr.ina.amalia.player.helpers.UtilitiesHelper.formatTime(b.duration,a.data.self.parameter.framerate,a.data.self.parameter.timeFormat);a.data.self.setCurrentTime(c),a.data.self.setDuration(d)}}),fr.ina.amalia.player.plugins.controlBar.widgets.WidgetBase.extend("fr.ina.amalia.player.plugins.controlBar.widgets.PlayButton",{classCss:"player-play-button",style:""},{initialize:function(){this.component=$("<div>",{"class":this.Class.classCss,style:this.Class.style});var a=$("<span>",{"class":"button-container"}),b=$("<i>",{"class":"fa fa-play fa-2x"});a.append(b),this.component.append(a),this.component.on("click",{self:this,component:this.component},this.onClick),this.container.append(this.component),this.definePlayerEvents()},definePlayerEvents:function(){this.mediaPlayer.mediaContainer.on(fr.ina.amalia.player.PlayerEventType.PLAYING,{self:this},this.onPlaying),this.mediaPlayer.mediaContainer.on(fr.ina.amalia.player.PlayerEventType.PAUSED,{self:this},this.onPaused)},onClick:function(a){a.data.self.mediaPlayer.play()},onPlaying:function(a){a.data.self.component.addClass("off").removeClass("on")},onPaused:function(a){a.data.self.component.addClass("on").removeClass("off")}}),fr.ina.amalia.player.plugins.controlBar.widgets.WidgetBase.extend("fr.ina.amalia.player.plugins.controlBar.widgets.PauseButton",{classCss:"player-pause-button",style:""},{initialize:function(){this.component=$("<div>",{"class":this.Class.classCss,style:this.Class.style});var a=$("<span>",{"class":"button-container round"}),b=$("<i>",{"class":"fa fa-pause fa-2x"});a.append(b),this.component.append(a),this.component.on("click",{self:this,component:this.component},this.onClick),this.container.append(this.component),this.definePlayerEvents(),this.component.addClass("off").removeClass("on")},definePlayerEvents:function(){this.mediaPlayer.mediaContainer.on(fr.ina.amalia.player.PlayerEventType.PLAYING,{self:this},this.onPlaying),this.mediaPlayer.mediaContainer.on(fr.ina.amalia.player.PlayerEventType.PAUSED,{self:this},this.onPaused)},onClick:function(a){a.data.self.mediaPlayer.pause()},onPlaying:function(a){a.data.self.component.addClass("on").removeClass("off")},onPaused:function(a){a.data.self.component.addClass("off").removeClass("on")}}),fr.ina.amalia.player.plugins.controlBar.widgets.WidgetBase.extend("fr.ina.amalia.player.plugins.controlBar.widgets.FullscreenButton",{classCss:"player-fullscreen-button",classCssFullscreenOn:"fa fa-expand fa-2x",classCssFullscreenOff:"fa fa-compress fa-2x",style:"",eventTypes:{CLICK:"fr.ina.amalia.player.plugins.widgets.FullscreenButton.event.click"}},{initialize:function(){this.component=$("<div>",{"class":this.Class.classCss,style:this.Class.style});var a=$("<span>",{"class":this.Class.classCssFullscreenOn});this.component.append(a),this.component.on("click",{self:this,component:this.component},this.onClick),this.container.append(this.component),this.setFullscreenMode(!1),null!==this.logger&&this.logger.trace(this.Class.fullName,"initialize"),this.definePlayerEvents()},definePlayerEvents:function(){this.mediaPlayer.mediaContainer.on(fr.ina.amalia.player.PlayerEventType.FULLSCREEN_CHANGE,{self:this},this.onFullscreenModeChange)},setFullscreenMode:function(a){a===!0?this.component.find("span").removeClass(this.Class.classCssFullscreenOn).addClass(this.Class.classCssFullscreenOff):this.component.find("span").removeClass(this.Class.classCssFullscreenOff).addClass(this.Class.classCssFullscreenOn)},onClick:function(a){a.data.self.mediaPlayer.toggleFullScreen()},onFullscreenModeChange:function(a,b){a.data.self.setFullscreenMode(b.inFullScreen)}}),fr.ina.amalia.player.plugins.controlBar.widgets.WidgetBase.extend("fr.ina.amalia.player.plugins.controlBar.widgets.VolumeControlBar",{classCss:"player-volume-control",classCssVolumeOn:"fa-volume-up",classCssVolumeOff:"fa-volume-off",style:"",eventTypes:{CLICK:"fr.ina.amalia.player.plugins.widgets.VolumeControlBar.event.click",CHANGE:"fr.ina.amalia.player.plugins.widgets.VolumeControlBar.event.change",HOVER:"fr.ina.amalia.player.plugins.widgets.VolumeControlBar.event.hover"}},{sliderStart:0,sliderEnd:100,defaultValue:100,volumeControlComponent:null,initialize:function(){this.component=$("<div>",{"class":this.Class.classCss,style:this.Class.style});var a='<input class="volume-control" data-width="70" data-height="70" data-displayInput="false" data-displayPrevious="true" data-skin="tron" data-thickness=".2" data-fgColor="#13e7f0"value="'+this.defaultValue+'" >';this.component.append(a);var b=$("<div>",{"class":"volume-control-btn"}),c=$("<span>",{"class":"fa fa-2x"});b.append(c);var d=this;this.component.find("input.volume-control").knob({change:function(a){d.onSlide(a)}}),b.on("click",{self:this},this.onClickVolume),this.component.find("div").append(b),this.container.append(this.component),this.definePlayerEvents(),null!==this.logger&&this.logger.trace(this.Class.fullName,"initialize")},definePlayerEvents:function(){this.mediaPlayer.mediaContainer.on(fr.ina.amalia.player.PlayerEventType.VOLUME_CHANGE,{self:this},this.onPlayerVolumeChange)},onClick:function(a){a.data.component.trigger(a.data.self.Class.eventTypes.CLICK),null!==a.data.self.logger&&a.data.self.logger.trace(a.data.self.Class.fullName,"onClick/triggerevent:"+a.data.self.Class.eventTypes.CLICK)},setValue:function(a){this.component.find("input.volume-control").val(a).trigger("change"),0===a?(this.component.find(".volume-control-btn span:first").removeClass(this.Class.classCssVolumeOn),this.component.find(".volume-control-btn span:first").addClass(this.Class.classCssVolumeOff)):(this.component.find(".volume-control-btn span:first").removeClass(this.Class.classCssVolumeOff),this.component.find(".volume-control-btn span:first").addClass(this.Class.classCssVolumeOn))},onSlide:function(a){this.component.trigger(this.Class.eventTypes.CHANGE,{value:a}),this.mediaPlayer.setVolume(a),null!==this.logger&&this.logger.trace(this.Class.fullName,"onSlide/triggerevent:"+this.Class.eventTypes.CHANGE+" Value "+a)},onClickVolume:function(a){var b=$(a.currentTarget).find("span:first").hasClass(a.data.self.Class.classCssVolumeOn)===!0?0:100;a.data.self.mediaPlayer.setVolume(b),null!==a.data.self.logger&&a.data.self.logger.trace(a.data.self.Class.fullName,"onClickVolume:"+a.data.self.Class.eventTypes.CHANGE+" Value "+b)},onPlayerVolumeChange:function(a,b){null!==a.data.self.logger&&a.data.self.logger.trace(a.data.self.Class.fullName,"onPlayerVolumeChange"+parseInt(b.volume)),a.data.self.setValue(parseInt(b.volume))}}),fr.ina.amalia.player.plugins.controlBar.widgets.WidgetBase.extend("fr.ina.amalia.player.plugins.controlBar.widgets.ProgressBar",{classCss:"player-progress-bar",style:""},{sliderStart:0,sliderEnd:1e3,sliding:!1,defaultValue:0,lastSlideEvent:0,initialize:function(){this.component=$("<div>",{"class":this.Class.classCss,style:this.Class.style}),this.component.slider({range:"min",min:this.sliderStart,max:this.sliderEnd,value:this.defaultValue,height:20,framepreview:!0,framepreviewTimeBound:500}),this.component.prepend($("<div>",{"class":"buffer-bar"})),this.component.on("slidestart",{self:this,component:this.component},this.onSlideStart),this.component.on("slidestop",{self:this,component:this.component},this.onSlideStop),this.parameter.framepreview===!0&&this.component.on("slide",{self:this,component:this.component},this.onSlide),this.container.append(this.component),this.definePlayerEvents()},setValue:function(a){this.sliding===!1&&this.component.slider("value",10*a)},setTitle:function(a){this.component.attr("title",a)},updateBuffer:function(a,b){this.component.find(".buffer-bar").css({left:a+"%",width:b+"%"})},definePlayerEvents:function(){this.mediaPlayer.mediaContainer.on(fr.ina.amalia.player.PlayerEventType.TIME_CHANGE,{self:this},this.onTimechange)},onTimechange:function(a,b){var c=fr.ina.amalia.player.helpers.UtilitiesHelper.formatTime(b.currentTime,a.data.self.settings.framerate,a.data.self.settings.timeFormat);a.data.self.setValue(b.percentage),a.data.self.setTitle(c);var d=a.data.self.mediaPlayer.getMediaPlayer().get(0).buffered.end(0),e=100*d/b.duration;a.data.self.updateBuffer(0,e)},onSlideStart:function(a,b){a.data.self.sliding=!0,a.data.self.mediaPlayer.pause(),null!==a.data.self.logger&&a.data.self.logger.trace(a.data.self.Class.fullName,"onSlideStart Value : "+b.value)},onSlideStop:function(a,b){a.data.self.sliding=!1;var c=a.data.self.mediaPlayer.getDuration(),d=b.value/10,e=(c-a.data.self.mediaPlayer.getTcOffset())*d/100;a.data.self.mediaPlayer.setCurrentTime(e+a.data.self.mediaPlayer.getTcOffset()),a.data.self.mediaPlayer.play(),null!==a.data.self.logger&&a.data.self.logger.trace(a.data.self.Class.fullName,"onSlideStop value : "+b.value)},onSlide:function(a,b){var c=new Date,d=c-a.data.self.lastSlideEvent;if(d>a.data.self.parameter.framepreviewTimeBound){a.data.self.lastSlideEvent=new Date;var e=a.data.self.mediaPlayer.getDuration(),f=b.value/10,g=(e-a.data.self.mediaPlayer.getTcOffset())*f/100;a.data.self.mediaPlayer.setCurrentTime(g+a.data.self.mediaPlayer.getTcOffset()),null!==a.data.self.logger&&a.data.self.logger.trace(a.data.self.Class.fullName,"onSlide value : "+b.value)}}}),fr.ina.amalia.player.plugins.controlBar.widgets.WidgetBase.extend("fr.ina.amalia.player.plugins.controlBar.widgets.Label",{classCss:"iplayer-Label label label-default",style:"",eventTypes:{}},{initialize:function(){this.component=$("<div>",{"class":this.Class.classCss,style:this.Class.style,text:this.parameter.defaultValue}),this.container.append(this.component),null!==this.logger&&this.logger.trace(this.Class.fullName,"initialize")},setValue:function(a){this.component.html(a)}}),fr.ina.amalia.player.plugins.PluginBase.extend("fr.ina.amalia.player.plugins.CustomControlBarPlugin",{classCss:"plugin-custom-controlbar"},{container:null,leftContainer:null,midContainer:null,rightContainer:null,widgets:null,height:130,progressBar:null,autoHide:!0,displayState:!0,hideDuration:500,autoHideStarted:!1,initialize:function(){this.settings=$.extend({height:130,autohide:!0,hideDuration:500,timeFormat:this.settings.sticky===!0?"s":"ms",framerate:25,framepreview:!1,framepreviewTimeBound:500,sticky:!1,widgets:{left:{timelabelWidget:"fr.ina.amalia.player.plugins.controlBar.widgets.TimeLabel"},mid:{playWidget:"fr.ina.amalia.player.plugins.controlBar.widgets.PlayButton",pauseWidget:"fr.ina.amalia.player.plugins.controlBar.widgets.PauseButton"},right:{full:"fr.ina.amalia.player.plugins.controlBar.widgets.FullscreenButton",volume:"fr.ina.amalia.player.plugins.controlBar.widgets.VolumeControlBar"},settings:{}}},this.settings||{}),this.leftContainer=null,this.midContainer=null,this.rightContainer=null,this.widgets=[],this.autoHide=this.settings.sticky===!0?!1:this.settings.autohide,this.displayState=!0,this.hideDuration=this.settings.hideDuration,this.height=this.settings.height,this.autoHideStarted=!1,this.createControlBar(),this.initializeWidgets(),this.definePlayerListeners(),this.updatePlayerSize(!1),null!==this.logger&&(this.logger.trace(this.Class.fullName,"initialize"),this.logger.info(this.settings))
},createControlBar:function(){var a=this.settings.sticky===!0?this.Class.classCss+" sticky":this.Class.classCss;this.container=$("<div>",{"class":a});var b=$("<div>",{"class":"row"});this.leftContainer=$("<div>",{"class":"left-container col-xs-4 col-md-4 col-lg-4"}),this.midContainer=$("<div>",{"class":"middle-container col-xs-4 col-md-4 col-lg-4"}),this.rightContainer=$("<div>",{"class":"right-container col-xs-4 col-md-4 col-lg-4"}),b.append(this.leftContainer),b.append(this.midContainer),b.append(this.rightContainer),this.container.append(b),this.container.height(this.height),this.pluginContainer.append(this.container)},initializeWidgets:function(){var a=this.settings.widgets;if(null!==this.logger&&(this.logger.trace(this.Class.fullName,"initialize"),this.logger.info(a)),a.hasOwnProperty("left"))for(var b in a.left)this.initWidget(b,a.left[b],this.leftContainer);if(a.hasOwnProperty("mid"))for(var c in a.mid)this.initWidget(c,a.mid[c],this.midContainer);if(a.hasOwnProperty("right"))for(var d in a.right)this.initWidget(d,a.right[d],this.rightContainer);this.settings.enableProgressBar!==!1&&(this.progressBar=new fr.ina.amalia.player.plugins.controlBar.widgets.ProgressBar({debug:this.settings.debug,framepreview:this.settings.framepreview,framepreviewTimeBound:this.settings.framepreviewTimeBound},this.mediaPlayer,this.container))},initWidget:function(widgetName,widgetClassName,container){try{var settings="object"==typeof this.settings.widgets.settings[widgetName]?this.settings.widgets.settings[widgetName]:this.settings,obj=eval("new "+widgetClassName+"(settings,this.mediaPlayer,container)");this.widgets.push(obj)}catch(error){null!==this.logger&&(this.logger.warn("Error to load widget : "+widgetClassName),this.logger.warn(error.stack))}},definePlayerListeners:function(){this.mediaPlayer.mediaContainer.on(fr.ina.amalia.player.PlayerEventType.FULLSCREEN_CHANGE,{self:this},this.onFullscreenModeChange),this.autoHide===!0&&(this.mediaPlayer.mediaContainer.one(fr.ina.amalia.player.PlayerEventType.PLAYING,{self:this},this.onPlaying),this.mediaPlayer.mediaContainer.one(fr.ina.amalia.player.PlayerEventType.SEEK,{self:this},this.onSeeking)),null!==this.logger&&this.logger.trace(this.Class.fullName,"defineWidgetsListeners")},updatePlayerSize:function(a){this.settings.sticky===!0?a===!0?this.mediaPlayer.mediaContainer.find("video").first().css("height",parseInt(window.screen.height-this.height)):this.mediaPlayer.mediaContainer.find("video").first().css("height",parseInt(this.mediaPlayer.mediaContainer.parent().height()-this.height)):this.container.css("bottom",this.height+"px")},show:function(){var a=this;a.displayState===!1&&(a.container.find(".row").show(),a.container.find(".player-progress-bar").css("height","20px"),a.container.find(".player-progress-bar .ui-slider-handle").css("width","20px"),a.container.animate({bottom:a.height+"px"},250,function(){a.displayState=!0}))},hide:function(){var a=this;a.displayState===!0&&a.container.animate({bottom:"10px"},250,function(){a.container.find(".row").hide(),a.container.find(".player-progress-bar").css("height","10px"),a.container.find(".player-progress-bar .ui-slider-handle").css("width","10px"),a.displayState=!1})},onFullscreenModeChange:function(a,b){a.data.self.updatePlayerSize(b.inFullScreen)},onPlayerMouseEnter:function(a){a.data.self.displayState===!1&&a.data.self.show(),null!==a.data.self.logger&&a.data.self.logger.trace(a.data.self.Class.fullName,"onPlayerMouseEnter")},onPlayerMouseLeave:function(a){a.data.self.displayState===!0&&setTimeout(function(){a.data.self.hide()},a.data.self.hideDuration),null!==a.data.self.logger&&a.data.self.logger.trace(a.data.self.Class.fullName,"onPlayerMouseLeave")},onPlaying:function(a){a.data.self.autoHideStarted===!1&&(a.data.self.autoHideStarted=!0,a.data.self.mediaPlayer.mediaContainer.on("mouseenter touchstart",{self:a.data.self},a.data.self.onPlayerMouseEnter),a.data.self.mediaPlayer.mediaContainer.on("mouseleave touchleave",{self:a.data.self},a.data.self.onPlayerMouseLeave))},onSeeking:function(a){a.data.self.autoHideStarted===!1&&(a.data.self.autoHideStarted=!0,a.data.self.hide(),a.data.self.mediaPlayer.mediaContainer.on("mouseenter touchstart",{self:a.data.self},a.data.self.onPlayerMouseEnter),a.data.self.mediaPlayer.mediaContainer.on("mouseleave touchleave",{self:a.data.self},a.data.self.onPlayerMouseLeave))}}),fr.ina.amalia.player.plugins.PluginBase.extend("fr.ina.amalia.player.plugins.ContextMenuPlugin",{classCss:"plugin-context-menu dropdown-menu lg",style:"",copyrightText:"Amalia.js V1.2.3, © INA 2015",copyrightHomepage:"http://ina-foss.github.io/amalia.js"},{container:null,menuConfiguration:{position:{my:"left top",at:"right top"}},initialize:function(){this.initContextMenu()},initContextMenu:function(){this.container=$("<ul/>",{"class":this.Class.classCss,style:this.Class.style,role:"menu","aria-labelledby":"dLabel"}).menu({disabled:!1}).css({position:"fixed",left:0,top:0}).hide(),this.addItemWithLink(this.Class.copyrightText),this.addItemWithLink(fr.ina.amalia.player.PlayerMessage.PLAYER_OPENSOURCE_LINK,this.Class.copyrightHomepage,"homepage"),this.pluginContainer.append(this.container),this.container.on("mouseleave",{self:this},this.onMouseleave),this.pluginContainer.parent().on("contextmenu",{self:this},this.onContextmenu)},addItemWithLink:function(a,b,c){b=b?b:"#",c=c?c:"disabled";var d=$("<li>",{"class":c}),e=$("<a>",{text:a,target:"_blank",href:b});return d.append(e),this.container.append(d),d},onContextmenu:function(a){var b=10;a.data.self.container.show().css({left:a.clientX-b,top:a.clientY-b}),a.preventDefault()},onMouseleave:function(a){a.preventDefault(),a.data.self.container.hide()}}),$.Class("fr.ina.amalia.player.parsers.MetadataParser",{},{settings:{},logger:null,data:null,init:function(a){this.settings=$.extend({debug:!1},a||{}),"undefined"!=typeof fr.ina.amalia.player.log&&"undefined"!=typeof fr.ina.amalia.player.log.LogHandler&&(this.logger=new fr.ina.amalia.player.log.LogHandler({enabled:this.settings.debug}))},parseData:function(a){var b=null;if(null!==this.logger&&this.logger.trace(this.Class.fullName,"parseData"),"undefined"!=typeof a.length){b=[];for(var c in a)a[c].hasOwnProperty("id")===!0?b.push(this.getData(a[c])):null!==this.logger&&this.logger.warn("parseData : Error to find data type.")}else a.hasOwnProperty("id")===!0?b=this.getData(a):null!==this.logger&&this.logger.warn("parseData : Error to find data type.");return b},getData:function(a){var b=null;if(b={},b.id=a.id,b.type=a.type,b.list=[],a.hasOwnProperty("localisation")===!0&&a.localisation.length>0&&a.localisation[0].hasOwnProperty("sublocalisations")===!0)for(var c=null!==a.localisation[0].sublocalisations?a.localisation[0].sublocalisations.localisation:a.localisation,d=null,e=null,f="",g="",h=0;h<c.length;h++)e=c[h],f=e.hasOwnProperty("label")===!0?e.label:"",g=e.hasOwnProperty("thumb")===!0?e.thumb:null,e.hasOwnProperty("tc")===!0&&null!==e.tc?(d={spatials:e.hasOwnProperty("spatials")===!0?e.spatials:null,data:e.hasOwnProperty("data")===!0?e.data:null,sublocalisations:e.hasOwnProperty("sublocalisations")===!0?e.sublocalisations:null,label:f,thumb:g,tclevel:e.hasOwnProperty("tclevel")===!0?e.tclevel:0,tc:fr.ina.amalia.player.helpers.UtilitiesHelper.convertHourToSeconde(e.tc)},b.list.push(d)):e.hasOwnProperty("tcin")===!0&&e.hasOwnProperty("tcout")===!0&&(d={spatials:e.hasOwnProperty("spatials")===!0?e.spatials:null,data:e.hasOwnProperty("data")===!0?e.data:null,sublocalisations:e.hasOwnProperty("sublocalisations")===!0?e.sublocalisations:null,label:f,thumb:g,tclevel:e.hasOwnProperty("tclevel")===!0?e.tclevel:0,tc:fr.ina.amalia.player.helpers.UtilitiesHelper.convertHourToSeconde(e.tcin),tcin:fr.ina.amalia.player.helpers.UtilitiesHelper.convertHourToSeconde(e.tcin),tcout:fr.ina.amalia.player.helpers.UtilitiesHelper.convertHourToSeconde(e.tcout),duration:fr.ina.amalia.player.helpers.UtilitiesHelper.convertHourToSeconde(e.tcout)-fr.ina.amalia.player.helpers.UtilitiesHelper.convertHourToSeconde(e.tcin)},b.list.push(d));return b}}),$.Class("fr.ina.amalia.player.LocalStorageManager",{storageNamespace:"ina.media.player"},{settings:{},logger:null,data:null,init:function(){this.initializeStorage()},initializeStorage:function(){if("undefined"!=typeof localStorage)try{localStorage.hasOwnProperty(this.Class.storageNamespace)===!1&&localStorage.setItem(this.Class.storageNamespace,JSON.stringify({})),this.data=JSON.parse(localStorage.getItem(this.Class.storageNamespace))}catch(a){this.data=null}else this.data=null},updateDataStorage:function(){try{"undefined"!=typeof localStorage&&localStorage.setItem(this.Class.storageNamespace,JSON.stringify(this.data))}catch(a){this.data=null}},hasItem:function(a){return null!==this.data&&this.data.hasOwnProperty(a)===!0},getItem:function(a){return null!==this.data&&this.data.hasOwnProperty(a)===!0?this.data[a]:null},setItem:function(a,b){try{null!==this.data&&"undefined"!=typeof a&&"undefined"!=typeof b&&(this.data[a]=b,this.updateDataStorage())}catch(c){}return null},removeItem:function(a){null!==this.data&&"undefined"!=typeof a&&(delete this.data[a],this.updateDataStorage())},clear:function(){"undefined"!=typeof localStorage&&localStorage.removeItem(this.Class.storageNamespace)}}),$.Class("fr.ina.amalia.player.mediaTypeManager",{},{mediaPlayer:null,logger:null,settings:{},init:function(a,b){if(this.mediaPlayer=b,this.namespace=this.Class.fullName,this.settings=$.extend({debug:!1,internalPlugin:!1},a||{}),void 0!==fr.ina.amalia.player.log&&void 0!==fr.ina.amalia.player.log.LogHandler&&(this.logger=new fr.ina.amalia.player.log.LogHandler({enabled:this.settings.debug})),null===this.mediaPlayer)throw new Error("Can't initialize plugin name"+this.Class.fullName);this.initialize()},initialize:function(){}}),fr.ina.amalia.player.mediaTypeManager.extend("fr.ina.amalia.player.media.type.DashMpeg",{},{context:null,dashPlayer:null,initialize:function(){this.context=new Dash.di.DashContext,this.dashPlayer=new MediaPlayer(this.context)},setSrc:function(a){this.dashPlayer.startup(),this.dashPlayer.attachView(this.mediaPlayer.get(0)),this.dashPlayer.attachSource(a),null!==this.logger&&this.logger.trace(this.Class.fullName,"set dash src :"+this.url)}}),$.Class("fr.ina.amalia.player.PlayerHtml5",{mediaPlayerClassCss:"player",mediaPlayerStyleCss:"position: relative; width: inherit; height: inherit; background-color: black; "},{logger:null,settings:{},mediaContainer:null,mediaPlayer:null,pluginManager:null,localStorageManager:null,listOfMetadata:[],loaderContainer:null,errorContainer:null,isIOSDevices:!1,isRangePlayer:!1,rangePlayerTcout:null,captureId:null,captureTc:null,captureScale:1,zTcin:null,zTcout:null,tcOffset:0,mediaTypeManager:null,init:function(a,b){this.settings=$.extend({autoplay:!1,poster:"",src:"",defaultVolume:75,crossorigin:""},a||{}),void 0!==fr.ina.amalia.player.log&&void 0!==fr.ina.amalia.player.log.LogHandler&&(this.logger=new fr.ina.amalia.player.log.LogHandler({enabled:this.settings.debug})),this.mediaContainer=b,this.initialize()},initialize:function(){null!==this.logger&&this.logger.trace(this.Class.fullName,"initialize");var a=-1!==navigator.userAgent.indexOf("iPhone"),b=-1!==navigator.userAgent.indexOf("iPod"),c=-1!==navigator.userAgent.indexOf("iPad");this.isIOSDevices=a||c||b,this.tcOffset=parseInt(this.settings.tcOffset),this.createLoaderContainer(),this.createErrorContainer(),this.createPlayer(),this.initializePlugins(),this.localStorageManager=new fr.ina.amalia.player.LocalStorageManager({}),this.setSrc(this.settings.src,this.settings.autoplay),this.setVolume(this.localStorageManager.hasItem("volume")===!1?this.settings.defaultVolume:this.localStorageManager.getItem("volume"))},initializePlugins:function(){null!==this.logger&&this.logger.trace(this.Class.fullName,"initializePlugins"),this.pluginManager=new fr.ina.amalia.player.plugins.PluginManager(this.settings,this,this.mediaContainer)},setSrc:function(a,b){null!==this.logger&&this.logger.trace(this.Class.fullName,"setSrc:"+a),"mpd"===this.settings.mediaType?(this.mediaTypeManager=new fr.ina.amalia.player.media.type.DashMpeg(this.settings,this.mediaPlayer),this.mediaTypeManager.setSrc(a)):(this.mediaPlayer.find("source:first").attr({src:a}),this.load(),b===!0&&this.play())},createPlayer:function(){if(null!==this.logger&&this.logger.trace(this.Class.fullName,"createPlayer"),this.mediaPlayer=$("<video/>",{"class":this.Class.mediaPlayerClassCss,style:this.Class.mediaPlayerStyleCss}),""!==this.settings.crossorigin&&this.mediaPlayer.attr("crossorigin",this.settings.crossorigin),""!==this.settings.poster&&this.mediaPlayer.attr("poster",this.settings.poster),"mpd"!==this.settings.mediaType){var a=$("<source />");this.mediaPlayer.append(a)}this.mediaContainer.append(this.mediaPlayer),this.initEvents()},createLoaderContainer:function(){this.loaderContainer=$("<div>",{"class":"inaplayer-loader"});var a=$("<i>",{"class":"fa fa-cog fa-spin fa-5x"});this.loaderContainer.append(a),this.loaderContainer.hide(),this.mediaContainer.append(this.loaderContainer),this.showLoader()},createErrorContainer:function(){this.errorContainer=$("<div>",{"class":"inaplayer-error"}),this.errorContainer.hide(),this.mediaContainer.append(this.errorContainer)},initEvents:function(){null!==this.logger&&this.logger.trace(this.Class.fullName,"adEvents"),this.mediaPlayer.on("loadstart",{self:this},this.onLoadstart),this.mediaPlayer.on("playing",{self:this},this.onPlay),this.mediaPlayer.on("pause",{self:this},this.onPause),this.mediaPlayer.on("ended",{self:this},this.onEnded),this.mediaPlayer.one("durationchange",{self:this},this.onDurationchange),this.mediaPlayer.on("timeupdate",{self:this},this.onTimeupdate),this.mediaPlayer.find("source").on("error",{self:this},this.onSourceError),this.mediaPlayer.on("seeked",{self:this},this.onSeeked),this.mediaPlayer.on(fr.ina.amalia.player.PlayerEventType.ERROR,{self:this},this.onError),$(document).on("webkitfullscreenchange mozfullscreenchange fullscreenchange MSFullscreenChange",{self:this},this.fullScreenHandler)},load:function(){this.mediaPlayer.get(0).load()},showLoader:function(){this.loaderContainer.show()},hideLoader:function(){this.loaderContainer.hide()},play:function(){if(this.mediaPlayer.get(0).play(),"undefined"!=typeof this.settings.callbacks.onPlay)try{eval(this.settings.callbacks.onPlay+"()")}catch(e){null!==this.logger&&this.logger.warn("Send callback failed.")}},pause:function(){if(this.mediaPlayer.get(0).pause(),this.isRangePlayer=!1,this.rangePlayerTcout=null,"undefined"!=typeof this.settings.callbacks.onPause)try{eval(this.settings.callbacks.onPause+"()")}catch(e){null!==this.logger&&this.logger.warn("Send callback failed.")}},stop:function(){if(this.mediaPlayer.get(0).pause(),this.mediaPlayer.get(0).currentTime=0,"undefined"!=typeof this.settings.callback.onStop)try{eval(this.settings.callbacks.onStop+"()")}catch(e){null!==this.logger&&this.logger.warn("Send callback failed.")}},seek:function(a){return this.setCurrentTime(a)},mute:function(){return this.mediaPlayer.trigger(fr.ina.amalia.player.PlayerEventType.MUTE),this.mediaPlayer.get(0).volume=0},unmute:function(){this.mediaPlayer.trigger(fr.ina.amalia.player.PlayerEventType.UN_MUTE),this.mediaPlayer.get(0).volume=1},getMediaPlayer:function(){return this.mediaPlayer},getDuration:function(){return Math.max(this.tcOffset,this.mediaPlayer.get(0).duration+this.tcOffset)},getTcOffset:function(){return this.tcOffset},getVolume:function(){return 100*this.mediaPlayer.get(0).volume},rangePlay:function(a,b,c){c="undefined"==typeof c?!1:c,this.isRangePlayer=!0,this.rangePlayerTcout=b+this.tcOffset,this.setCurrentTime(a),c===!0&&this.play()},setVolume:function(a){return a>=0&&100>=a?(this.mediaPlayer.trigger(fr.ina.amalia.player.PlayerEventType.VOLUME_CHANGE,{volume:a}),this.localStorageManager.setItem("volume",a),null!==this.logger&&this.logger.trace(this.Class.fullName,"setVolume"+a),this.mediaPlayer.get(0).volume=a/100):null},setCurrentTime:function(a){var b=isNaN(a)?0:a;return this.mediaPlayer.trigger(fr.ina.amalia.player.PlayerEventType.SEEK,{currentTime:b}),this.mediaPlayer.get(0).currentTime=Math.max(0,b-this.tcOffset)},setErrorCode:function(a){if("undefined"!=typeof this.errorContainer){var b=$("<p>",{text:fr.ina.amalia.player.PlayerErrorCode.getMessage(a)});this.errorContainer.html(b),this.errorContainer.show()}},getFullscreen:function(){return fr.ina.amalia.player.helpers.HTML5Helper.isFullScreen()},getCurrentTime:function(){return this.mediaPlayer.get(0).currentTime+this.tcOffset},isPaused:function(){return this.mediaPlayer.get(0).paused},toggleFullScreen:function(){var container=this.isIOSDevices?this.mediaPlayer.get(0):this.mediaContainer.get(0),inFullScreen=fr.ina.amalia.player.helpers.HTML5Helper.toggleFullScreen(container,this.isIOSDevices);if("undefined"!=typeof this.settings.callbacks.onFullscreen)try{eval(this.settings.callbacks.onFullscreen+"(inFullScreen)")}catch(e){null!==this.logger&&this.logger.warn("Send callback failed.")}return null!==this.logger&&this.logger.trace(this.Class.fullName,"onClickFullscreenButton :"+inFullScreen),inFullScreen},fullScreenHandler:function(a){var b=$(document).context,c=b.fullscreen||b.mozFullScreen||b.webkitIsFullScreen?!0:!1;a.data.self.mediaPlayer.trigger(fr.ina.amalia.player.PlayerEventType.FULLSCREEN_CHANGE,{inFullScreen:c}),null!==a.data.self.logger&&a.data.self.logger.trace(a.data.self.Class.fullName,"fullScreenHandler :"+c)},addMetadata:function(a){if("object"==typeof a){var b=new fr.ina.amalia.player.parsers.MetadataParser(this.settings),c=b.parseData(a);if(null!==c){if("undefined"!=typeof a.length)for(var d in c)c[d].hasOwnProperty("id")===!0?("undefined"==typeof this.listOfMetadata[c[d].id]&&(this.listOfMetadata[c[d].id]=[]),this.listOfMetadata[c[d].id].push(c[d].list),null!==this.logger&&this.logger.info("AddMetadata ID:"+c[d].id)):null!==this.logger&&this.logger.warn("parseData : Error to find data type.");else"undefined"==typeof this.listOfMetadata[c.id]&&(this.listOfMetadata[c.id]=[],this.listOfMetadata[c.id].push(c.list));null!==this.logger&&this.logger.info("AddMetadata ID:"+c.id)}else null!==this.logger&&this.logger.warn("AddMetadata/Error to parse data.")}else null!==this.logger&&this.logger.warn("AddMetadata/Error: data is not object.")},setZoomTc:function(a,b,c){c="undefined"!=typeof c?c:"",(Math.ceil(this.zTcin)!==Math.ceil(a)||Math.ceil(this.zTcout)!==Math.ceil(b))&&(this.zTcin=Math.max(0,parseFloat(a)),this.zTcout=parseFloat(b),null!==this.logger&&this.logger.info("SetZoomTc: // Tcin: "+this.zTcin+" // Tcout:"+this.zTcout+" // Event Tag Name:"+c),this.mediaPlayer.trigger(fr.ina.amalia.player.PlayerEventType.ZOOM_RANGE_CHANGE,{zTcin:parseFloat(a),zTcout:parseFloat(b),eventTag:c}))},getMetadataById:function(a){return this.listOfMetadata[a]},setMetadataById:function(a,b){if("object"==typeof b)this.listOfMetadata[a]=b;else{if("string"!=typeof b)return!1;try{var c=JSON.parse(b);this.listOfMetadata[a]=c}catch(d){return!1}}return this.mediaPlayer.trigger(fr.ina.amalia.player.PlayerEventType.DATA_CHANGE,{id:a}),!0},getMetadataWithRange:function(a,b,c){var d=this.getMetadataById(a),e=[];if("undefined"!=typeof d){for(var f=0;f<d.length;f++)e=e.concat(this._getMetadataRangeValues(d[f],parseFloat(b),parseFloat(c)));null!==this.logger&&this.logger.trace(this.Class.fullName,"getMetadataWithRange Id:"+a+" Tcin:"+b+" Tcout:"+c+" Number of Elements:"+d.length)}else null!==this.logger&&this.logger.warn("GetMetadataWithRange:  No data id:"+a);return e},_getMetadataRangeValues:function(a,b,c){return $.grep(a,function(a){return a.tc>=b&&a.tc<=c})},getCurrentImage:function(a){var b="";try{var c=this.mediaPlayer.get(0),d=document.createElement("canvas");return a="undefined"!=typeof a?Math.min(1,parseFloat(a)):1,d.width=c.videoWidth*a,d.height=c.videoHeight*a,d.getContext("2d").drawImage(c,0,0,d.width,d.height),b=d.toDataURL("image/png"),this.mediaPlayer.trigger(fr.ina.amalia.player.PlayerEventType.IMAGE_CAPTURE,{currentTime:this.getCurrentTime(),captureTc:this.captureTc.toString(),captureId:this.captureId.toString(),captureImage:b.toString()}),b}catch(e){null!==this.logger&&(this.logger.warn("Error lors de la capture d'imagette"),this.logger.warn(e.stack))}return b},getTcImage:function(a,b,c){this.setCurrentTime(b),this.play(),this.captureId=a,this.captureTc=b+this.tcOffset,this.captureScale="undefined"!=typeof c?Math.min(1,parseFloat(c)):1},onLoadstart:function(event){if(null!==event.data.self.logger&&event.data.self.logger.trace(event.data.self.Class.fullName,"onLoadstart"),"undefined"!=typeof event.data.self.settings.callbacks.onReady)try{eval(event.data.self.settings.callbacks.onReady+"()")}catch(e){null!==event.data.self.logger&&event.data.self.logger.warn("Send callback failed.")}},onPlay:function(a){null!==a.data.self.logger&&a.data.self.logger.trace(a.data.self.Class.fullName,"onPlay"),a.data.self.mediaPlayer.trigger(fr.ina.amalia.player.PlayerEventType.PLAYING,[a.data.self])},onPause:function(a){null!==a.data.self.logger&&a.data.self.logger.trace(a.data.self.Class.fullName,"onPause"),a.data.self.mediaPlayer.trigger(fr.ina.amalia.player.PlayerEventType.PAUSED,[a.data.self])},onSeeked:function(a){if(a.data.self.mediaPlayer.trigger(fr.ina.amalia.player.PlayerEventType.SEEK,{currentTime:a.data.self.getCurrentTime()}),"number"==typeof a.data.self.captureTc)try{a.data.self.getCurrentImage(a.data.self.captureScale),a.data.self.captureTc=null}catch(b){null!==a.data.self.logger&&(a.data.self.logger.warn("Error to capture Tc"),a.data.self.logger.warn(b.stack))}},onEnded:function(event){if(null!==event.data.self.logger&&event.data.self.logger.trace(event.data.self.Class.fullName,"onEnded"),event.data.self.mediaPlayer.trigger(fr.ina.amalia.player.PlayerEventType.ENDEN,[event.data.self]),"undefined"!=typeof event.data.self.settings.callbacks.onComplete)try{eval(event.data.self.settings.callbacks.onComplete+"()")}catch(e){null!==event.data.self.logger&&event.data.self.logger.warn("Send callback failed.")}},onDurationchange:function(a){a.data.self.hideLoader(),a.data.self.mediaPlayer.trigger(fr.ina.amalia.player.PlayerEventType.STARTED,[a.data.self]),a.data.self.settings.autoplay===!0&&a.data.self.play()},onTimeupdate:function(event){var tcOffset=event.data.self.getTcOffset(),currentTime=event.data.self.getCurrentTime(),duration=event.data.self.getDuration(),percentage=100*(currentTime-tcOffset)/(duration-tcOffset);if(event.data.self.mediaPlayer.trigger(fr.ina.amalia.player.PlayerEventType.TIME_CHANGE,{self:event.data.self,currentTime:currentTime,duration:duration,percentage:percentage}),event.data.self.isRangePlayer===!0&&"number"==typeof event.data.self.rangePlayerTcout&&event.data.self.rangePlayerTcout<=currentTime&&event.data.self.pause(),"undefined"!=typeof event.data.self.settings.callbacks.onTimeupdate)try{eval(event.data.self.settings.callbacks.onTimeupdate+"(currentTime)")}catch(e){null!==event.data.self.logger&&event.data.self.logger.warn("Send callback failed.")}},onSourceError:function(a){null!==a.data.self.logger&&(a.data.self.logger.warn(a.data.self.Class.fullName+" :: onSourceError"),a.data.self.logger.warn(a)),a.data.self.mediaPlayer.trigger(fr.ina.amalia.player.PlayerEventType.ERROR,{self:a.data.self,errorCode:fr.ina.amalia.player.PlayerErrorCode.MEDIA_FILE_NOT_FOUND})},onError:function(event,data){null!==event.data.self.logger&&event.data.self.logger.trace(event.data.self.Class.fullName,"onError");var errorCode="undefined"==typeof data.errorCode?"":data.errorCode;if(event.data.self.setErrorCode(errorCode),"undefined"!=typeof event.data.self.settings.callbacks.onError)try{eval(event.data.self.settings.callbacks.onError+"(errorCode)")}catch(e){null!==event.data.self.logger&&event.data.self.logger.warn("Send callback failed.")}},addMenuItemWithLink:function(a,b,c){if("object"==typeof this.pluginManager&&"function"==typeof this.pluginManager.getContextMenuPlugin){var d=this.pluginManager.getContextMenuPlugin();if("object"==typeof d&&"function"==typeof d.addItemWithLink)return d.addItemWithLink(a,b,c)}return!1}}),function(a){a.fn.mediaPlayer=function(b){return this.each(function(){var c=a(this),d="fr.ina.amalia.player";if(c.data(d))return null;b=a.extend({plugins:{},src:null,framerate:25,autoplay:!0,controlBarClassName:"fr.ina.amalia.player.plugins.CustomControlBarPlugin",controlBar:{},tcOffset:0,mediaType:"mp4",debug:!1},b||{});var e=new fr.ina.amalia.player.MediaFactory(this,b);c.data(d,e),c.addClass("inaplayerhtml5"),c.attr("style","width: 100%; height:100%;"),c.parent().css("position","relative")})}}(jQuery),$.Class("fr.ina.amalia.player.plugins.timeline.BaseComponent",{ComponentClassCss:"default-component",ComponentModuleClassCss:"module-default",LocalStorageTimeDisplayStateNamespace:"timeline-display-state",NAV_CLICK:"fr.ina.amalia.player.plugins.timeline.event.NavClick",CLOSE_EVENT:"fr.ina.amalia.player.plugins.timeline.component.event.CloseEvent"},{logger:null,settings:{},mainContainer:null,tooltipConfiguration:{position:{my:"center bottom-20",at:"center top",delay:3e3,using:function(a,b){$(this).css(a),$("<div>").addClass("inaplayerhtml5-arrow").addClass(b.vertical).addClass(b.horizontal).appendTo(this)}},content:function(){var a=$(this),b=a.attr("title");if(a.is("[data-src]")){var c=a.attr("data-src");return"<img class='image' alt='"+b+"' src='"+c+"' />"}return b=b.replace(/(?:\r\n|\r|\n)/g,"<br />"),"<p>"+b+"</p>"}},zoomLevel:0,tcin:0,tcout:0,duration:0,displayStateList:["lg","md","sm","xs"],displayStateIdx:0,localStorageManager:null,zoomProperty:null,focusable:null,hasElements:!1,zoomable:!1,focusComponent:null,focusLine:null,listOfdata:null,zoomableZone:null,zTcin:0,zTcout:0,currentTime:0,init:function(a){if(this.settings=$.extend({debug:!1,icon:"circle",color:"#fff",container:"",metadataId:"",tcOffset:0,callbacks:{},duration:0,pointNav:!1,zoomHierarchies:!1,overlap:!1,withParentLevel:!1,zoomable:!0,focusable:!1,toolsbar:!0,editable:!1,closeable:!1,viewZoom:!1,marker:!1,timecursor:!1},a||{}),"undefined"!=typeof fr.ina.amalia.player.log&&"undefined"!=typeof fr.ina.amalia.player.log.LogHandler&&(this.logger=new fr.ina.amalia.player.log.LogHandler({enabled:this.settings.debug})),this.mainContainer=this.settings.container,this.localStorageManager=new fr.ina.amalia.player.LocalStorageManager({}),this.focusable=this.settings.focusable,this.zoomable=this.settings.zoomable,this.duration=parseFloat(this.settings.duration),this.zTcout=parseFloat(this.settings.duration),0===this.mainContainer.length||"object"!=typeof this.mainContainer)throw new Error("Your container is empty.");this.initialize()},initialize:function(){if(null!==this.logger&&this.logger.trace(this.Class.fullName,"initialize"),this.mainContainer.addClass(this.Class.ComponentClassCss),this.createAxis(),this.settings.toolsbar===!0&&this.createToolBar(),this.settings.focusable===!0&&this.createBottomToolsBar(),this.settings.closeable===!0&&this.createCloseToolBar(),this.settings.timecursor===!0&&(this.createTimeCursor(),this.mainContainer.parents(".inaplayerhtml5-plugin.plugin-timeline").first().on(fr.ina.amalia.player.plugins.TimelinePlugin.eventTypes.TIME_CHANGE,{self:this},this.onPluginTimeChange)),this.settings.focusable===!1&&this.settings.zoomable===!1&&this.settings.viewZoom===!0&&this.createZoomContainer(),"undefined"!=typeof this.settings.callbacks.onCreated)try{eval(this.settings.callbacks.onCreated+"(this)")}catch(e){null!==this.logger&&this.logger.warn("Error to create callback.")}},createAxis:function(){var a=$("<div>",{"class":"line"}),b=$("<div>",{"class":"line-content"});b.append(a);var c=$("<div>",{"class":this.Class.ComponentModuleClassCss});c.append(b);var d=$("<div>",{"class":"label",text:this.settings.title});c.append(d),this.mainContainer.append(c);var e=this.localStorageManager.getItem(this.Class.LocalStorageTimeDisplayStateNamespace);null===e?e=this.getDisplayState():(this.displayStateIdx=this.displayStateList.indexOf(e),this.displayStateIdx++),this.mainContainer.removeClass(this.displayStateList.toString().replace(/,/g," ")).addClass(e),null!==this.logger&&this.logger.trace(this.Class.fullName,"createAxis")},createToolBar:function(){var a=$("<div>",{"class":"toolbar-container"}),b=this.createButton(fr.ina.amalia.player.PlayerMessage.PLUGIN_TIMELINE_LABEL_EXPAND," expand-btn");b.on("click",{self:this},this.onClickExpandBtn),a.append(b);var c=$("<div>",{title:fr.ina.amalia.player.PlayerMessage.PLUGIN_TIMELINE_LABEL_SORT,"class":"sort-btn fa"}).tooltip(this.tooltipConfiguration);if(a.append(c),this.settings.pointNav===!0){var d=$("<div>",{"class":"nav-controls"}),e=this.createButton(fr.ina.amalia.player.PlayerMessage.PLUGIN_TIMELINE_LABEL_NAV_POINT_PREV,"chevron-circle-left prev-control");e.on("click",{self:this},this.onClickPrevNavContorl),d.append(e);var f=this.createButton(fr.ina.amalia.player.PlayerMessage.PLUGIN_TIMELINE_LABEL_NAV_POINT_NEXT,"chevron-circle-right next-control");f.on("click",{self:this},this.onClickNextNavContorl),d.append(f),a.append(d)}this.mainContainer.append(a)},createCloseToolBar:function(){var a=$("<div>",{"class":"toolbar-container"}),b=this.createButton(fr.ina.amalia.player.PlayerMessage.PLUGIN_TIMELINE_LABEL_CLOSE," close-btn");b.on("click",{self:this},this.onClickCloseBtn),a.append(b),this.mainContainer.append(a)},createTimeCursor:function(){var a=$("<div>",{"class":"timecursor",left:"0px"});this.mainContainer.append(a)},createButton:function(a,b,c){return c===!1?$("<button>",{value:a,"class":"fa fa-"+b}):$("<button>",{title:a,"class":"plugin-btn fa fa-"+b}).tooltip(this.tooltipConfiguration)},createBottomToolsBar:function(){var a=$("<div>",{"class":"bottom-toolbar-container"});if(this.settings.focusable===!0){var b=this.createButton(fr.ina.amalia.player.PlayerMessage.PLUGIN_TIMELINE_LABEL_FOCUS,"search-plus focus-btn");b.on("click",{self:this},this.onClickFocusBtn),a.append(b)}this.mainContainer.append(a)},createFocusComponent:function(){var focusSettings={debug:this.settings.debug};this.focusComponent=new fr.ina.amalia.player.plugins.components.FocusComponent(this.mainContainer,this.duration,focusSettings),this.focusComponent.setTc(this.tcin,this.tcout);try{var focusLineContainer=$("<div>",{"class":"sub",style:""});this.mainContainer.append(focusLineContainer);var focusLineSettings=jQuery.extend(!0,{},this.settings);focusLineSettings.container=focusLineContainer,focusLineSettings.focusable=!1,focusLineSettings.pointNav=!1,focusLineSettings.title="",focusLineSettings.toolsbar=!1,focusLineSettings.zoomHierarchies=!1,focusLineSettings.withParentLevel=!1,focusLineSettings.zoomable=!0,focusLineSettings.closeable=!0,focusLineSettings.color="#FFF",focusLineSettings.viewZoom=!1,this.focusLine=eval("new "+this.Class.fullName+"(focusLineSettings)"),this.focusLine.setTcin(this.focusComponent.getFocusTcin()),this.focusLine.setTcout(this.focusComponent.getFocusTcout()),this.mainContainer.on(fr.ina.amalia.player.plugins.components.FocusComponent.eventTypes.FOCUS_ZONE_CHANGE,{self:this},this.onFocusZoneChange),this.focusLine.mainContainer.on(this.Class.CLOSE_EVENT,{self:this},this.onCloseEventRecever),null!==this.focusLine&&(this.focusLine.removeItems(),this.focusLine.addItems(this.listOfdata))}catch(e){null!==this.logger&&this.logger.warn(e)}},createZoomContainer:function(){try{var a={debug:this.settings.debug,modeFocus:!1};this.zoomableZone=new fr.ina.amalia.player.plugins.components.FocusComponent(this.mainContainer,this.duration,a),this.zoomableZone.setTc(this.zTcin,this.zTcout)}catch(b){null!==this.logger&&this.logger.warn(b)}},show:function(){this.mainContainer.show()},hide:function(){this.mainContainer.hide()},getContainer:function(){return this.mainContainer},getMetadataId:function(){return this.settings.metadataId},setMetadataId:function(a){this.settings.metadataId=a},setTcin:function(a){(this.isZoomable()===!0||this.getHasElements()===!1)&&(this.tcin=parseFloat(a)),null!==this.focusComponent&&null!==this.focusLine&&(this.focusComponent.setTc(this.tcin,this.tcout),this.focusLine.setTcin(this.focusComponent.getFocusTcin()))
},setTcout:function(a){(this.isZoomable()===!0||this.getHasElements()===!1)&&(this.tcout=parseFloat(a)),null!==this.focusComponent&&null!==this.focusLine&&(this.focusComponent.setTc(this.tcin,this.tcout),this.focusLine.setTcout(this.focusComponent.getFocusTcout()))},setZoomTc:function(a,b){this.zTcin=parseFloat(a),this.zTcout=parseFloat(b),null!==this.zoomableZone&&this.zoomableZone.setZoomTc(this.zTcin,this.zTcout)},setZoomProperty:function(a){this.zoomProperty=a},setCurrentTime:function(a){this.currentTime=parseInt(a),this.settings.timecursor===!0&&this.updateTimeCursor()},getHasElements:function(){return this.hasElements},isFocusable:function(){return this.focusable},isZoomable:function(){return this.zoomable},addItems:function(a){null!==this.logger&&(this.logger.trace(this.Class.fullName," addItems/ZoomLevel:"+this.zoomLevel),this.logger.warn(a));var b=this.zoomProperty;if(this.hasElements=!0,null!==a){a.sort(function(a,c){return a.hasOwnProperty(b)&&c.hasOwnProperty(b)&&(a=parseInt(a[b]),c=parseInt(c[b])),a>c?1:c>a?-1:0}),a.sort(function(a,b){return a=parseInt(a.tc),b=parseInt(b.tc),a>b?1:b>a?-1:0}),this.settings.zoomHierarchies===!0&&(a=this.getHierarchiesData(this.zoomLevel,a,this.settings.withParentLevel));for(var c=0;c<a.length;c++)this.addItem(a[c]);this.updateTootip()}this.listOfdata=a,this.settings.overlap===!0&&this.updateDisplayItems(),null!==this.focusLine&&(this.focusLine.removeItems(),this.focusLine.addItems(a))},updateTootip:function(){this.mainContainer.find(".line-content .item.cuepoint").tooltip(this.tooltipConfiguration),this.mainContainer.find(".line-content .item.segment").tooltip(this.tooltipConfiguration)},updateTimeCursor:function(){this.mainContainer.find(".timecursor").css("left",100*(this.currentTime-this.tcin)/(this.tcout-this.tcin)+"%")},getHierarchiesData:function(a,b,c){var d=parseInt(a.toString()),e=[];if(c===!0){do{if(e=$(b).filter(function(a){return b[a].tclevel===d}),e.length>0)return e;a--}while(a>0)}else e=$(b).filter(function(a){return b[a].tclevel===d});return e},updateDisplayItems:function(){for(var a,b,c=this.mainContainer.find(".line-content").first().find(".item"),d=this.mainContainer.find(".line-content").first(),e=null,f=null,g=null,h=c.length-1;h>=0;h--)e=$(c[h]),h!==c.length-1?(f=$(d).find(".item.on").first(),f.length>0&&(a=f.offset().left,b=e.offset().left,g=e.hasClass("image")&&!e.hasClass("segment")?e.find("img").width():e.width(),a-b>g?(e.addClass("on"),e.show()):(e.addClass("off"),e.hide()))):e.addClass("on")},getDisplayState:function(){var a="";return this.displayStateIdx<this.displayStateList.length?(a=this.displayStateList[this.displayStateIdx],this.displayStateIdx++):(this.displayStateIdx=0,a=this.displayStateList[this.displayStateIdx],this.displayStateIdx++),this.localStorageManager.setItem(this.Class.LocalStorageTimeDisplayStateNamespace,a),a},changeDisplayState:function(){this.mainContainer.removeClass(this.displayStateList.toString().replace(/,/g," ")).addClass(this.getDisplayState())},getNextItem:function(a){var b=this.mainContainer.find(".line-content").first(),c=b.find(".item").filter(function(b,c){return parseFloat($(c).attr("data-tc"))>a}).first();return c.is("[data-tc]")?parseFloat(c.attr("data-tc")):null},getPrevItem:function(a){var b=this.mainContainer.find(".line-content").first(),c=b.find(".item").filter(function(b,c){return parseFloat($(c).attr("data-tc"))<a}).last();return c.is("[data-tc]")?parseFloat(c.attr("data-tc")):null},setZoomLevel:function(a){this.zoomLevel=a},onClickExpandBtn:function(a){try{a.data.self.mainContainer.hasClass("xs")?(a.data.self.mainContainer.removeClass(a.data.self.displayStateList.toString().replace(/,/g," ")),a.data.self.mainContainer.addClass("lg")):(a.data.self.mainContainer.removeClass(a.data.self.displayStateList.toString().replace(/,/g," ")),a.data.self.mainContainer.addClass("xs")),null!==a.data.self.logger&&a.data.self.logger.trace(a.data.self.Class.fullName," onClickExpandBtn hasClass :--"+a.data.self.mainContainer.hasClass("xs"))}catch(b){null!==a.data.self.logger&&a.data.self.logger.trace(a.data.self.Class.fullName,"initialize"+b.toString())}},onClickNextNavContorl:function(a){a.data.self.mainContainer.trigger(a.data.self.Class.NAV_CLICK,{type:"next"}),null!==a.data.self.logger&&a.data.self.logger.trace(a.data.self.Class.fullName,"onClickNextNavContorl")},onClickPrevNavContorl:function(a){a.data.self.mainContainer.trigger(a.data.self.Class.NAV_CLICK,{type:"prev"}),null!==a.data.self.logger&&a.data.self.logger.trace(a.data.self.Class.fullName,"onClickPrevNavContorl")},onClickFocusBtn:function(a){null===a.data.self.focusComponent&&a.data.self.createFocusComponent(),a.data.self.mainContainer.removeClass("focus-off").addClass("focus-on"),null!==a.data.self.logger&&a.data.self.logger.trace(a.data.self.Class.fullName,"onClickHierarchicalZoomBtn")},onFocusZoneChange:function(a,b){a.data.self.focusLine.removeItems(),a.data.self.focusLine.setTcin(b.focusTcin),a.data.self.focusLine.setTcout(b.focusTcout),a.data.self.focusLine.addItems(a.data.self.listOfdata)},onClickCloseBtn:function(a){a.data.self.mainContainer.trigger(a.data.self.Class.CLOSE_EVENT)},onCloseEventRecever:function(a){a.data.self.mainContainer.removeClass("focus-on").addClass("focus-off")},onPluginTimeChange:function(a,b){a.data.self.setCurrentTime(b.currentTime)}}),$.Class("fr.ina.amalia.player.plugins.components.FocusComponent",{CONTAINER_NAME:"focus-container",eventTypes:{FOCUS_ZONE_CHANGE:"fr.ina.amalia.player.plugins.components.FocusComponent.FOCUS_ZONE_CHANGE",ZOOM_ZONE_CHANGE:"fr.ina.amalia.player.plugins.components.FocusComponent.ZOOM_ZONE_CHANGE"}},{logger:null,settings:{},mainContainer:null,container:null,modeFocus:null,tcin:0,tcout:0,duration:0,init:function(a,b,c){if(this.settings=$.extend({debug:!1,modeFocus:!0},c||{}),this.modeFocus=this.settings.modeFocus,"undefined"!=typeof fr.ina.amalia.player.log&&"undefined"!=typeof fr.ina.amalia.player.log.LogHandler&&(this.logger=new fr.ina.amalia.player.log.LogHandler({enabled:this.settings.debug})),this.mainContainer=a,this.duration=parseFloat(b),0===this.mainContainer.length||"object"!=typeof this.mainContainer)throw new Error("Your container is empty.");this.initialize()},initialize:function(){null!==this.logger&&this.logger.trace(this.Class.fullName,"initialize"),this.createContainer(),this.setMode(),this.mainContainer.on(fr.ina.amalia.player.plugins.timeline.TimeAxisComponent.eventTypes.RANGE_CHANGE,{self:this},this.onTimeRangeChange)},createContainer:function(){this.container=$("<div>",{"class":this.Class.CONTAINER_NAME}),this.container.resizable({handles:"w,e",helper:"inalabplayer-ui-resizable-helper",start:function(a,b){var c=$(a.target).parent(),d=c.width()-b.element.position().left;$(a.target).resizable("option","minWidth",40),$(a.target).resizable("option","maxWidth",d)}}),this.container.on("resizestop",{self:this},this.onResizeStop),this.container.draggable({axis:"x",drag:function(a,b){var c=$(a.target),d=c.parent(),e=Math.max(0,b.position.left);b.position.left=Math.min(d.first().width()-c.width(),e)}}).css("position","absolute"),this.container.on("dragstop",{self:this},this.onDragStop),this.mainContainer.append(this.container),null!==this.logger&&this.logger.trace(this.Class.fullName,"createContainer")},setMode:function(){this.mainContainer.find("."+this.Class.CONTAINER_NAME).addClass(this.modeFocus===!0?"focus":"zoom")},getContainer:function(){return this.mainContainer},setTc:function(a,b){this.tcin=parseFloat(a),this.tcout=parseFloat(b),this.mainContainer.find("."+this.Class.CONTAINER_NAME).attr("tcin",parseFloat(a)),this.mainContainer.find("."+this.Class.CONTAINER_NAME).attr("tcout",parseFloat(b)),this.selectedZoneChange(),null!==this.logger&&this.logger.trace(this.Class.fullName,"setTc: default tc:"+this.tcin+":"+this.tcout)},setZoomTc:function(a,b){this.resize(100*(b-a)/this.duration,100*a/this.duration)},resize:function(a,b){this.mainContainer.find("."+this.Class.CONTAINER_NAME).first().css({width:Math.min(Math.max(0,parseFloat(a)),100)+"%",left:Math.min(Math.max(0,parseFloat(b)),100)+"%"}),this.container.trigger("dragstop")},selectedZoneChange:function(){var a=this.getFocusTcin(),b=this.getFocusTcout();this.modeFocus===!0?(this.mainContainer.trigger(this.Class.eventTypes.FOCUS_ZONE_CHANGE,{focusTcin:a,focusTcout:b}),null!==this.logger&&this.logger.trace(this.Class.fullName,"selectedZoneChange trigger event : "+this.Class.eventTypes.FOCUS_ZONE_CHANGE+" focus focusTcin:"+a+" focusTcout:"+b)):(this.mainContainer.trigger(this.Class.eventTypes.ZOOM_ZONE_CHANGE,{zTcin:a,zTcout:b}),null!==this.logger&&this.logger.trace(this.Class.fullName,"selectedZoneChange trigger event : "+this.Class.eventTypes.ZOOM_ZONE_CHANGE+" focus zTcin:"+a+" zTcout:"+b))},getFocusTcin:function(){var a=parseFloat((this.tcout-this.tcin)*this.mainContainer.find("."+this.Class.CONTAINER_NAME).first().position().left/this.mainContainer.first().width());return Math.max(0,this.tcin+a)},getFocusTcout:function(){var a=this.getFocusTcin(),b=parseFloat((this.tcout-this.tcin)*this.mainContainer.find("."+this.Class.CONTAINER_NAME).first().width()/this.mainContainer.first().width());return Math.min(this.duration,a+b)},onTimeRangeChange:function(a,b){a.data.self.setTc(b.tcin,b.tcout),null!==a.data.self.logger&&a.data.self.logger.trace(a.data.self.Class.fullName,"onTimeRangeChange default tc:"+b.tcin+":"+b.tcout)},onDragStop:function(a){null!==a.data.self.logger&&a.data.self.logger.trace(a.data.self.Class.fullName,"onDragStop"),a.data.self.selectedZoneChange()},onResizeStop:function(a,b){var c=$(b.element);a.data.self.modeFocus===!0?c.css("height","50%"):c.css("height","100%"),null!==a.data.self.logger&&a.data.self.logger.trace(a.data.self.Class.fullName,"onResizeStop"),a.data.self.selectedZoneChange()}}),$.Class("fr.ina.amalia.player.plugins.timeline.TicComponent",{eventTypes:{CLICK:"fr.ina.amalia.player.plugins.timeline.TicComponent.click",UPDATE_TC:"fr.ina.amalia.player.plugins.timeline.TicComponent.updatetc"}},{logger:null,container:null,settings:{},currentTcin:0,currentTcout:0,tooltipConfiguration:{position:{my:"center bottom-20",at:"center top",delay:3e3,using:function(a,b){$(this).css(a),$("<div>").addClass("inaplayerhtml5-arrow").addClass(b.vertical).addClass(b.horizontal).appendTo(this)}},content:function(){var a=$(this),b=a.attr("title");if(a.is("[data-src]")){var c=a.attr("data-src");return"<img class='image' alt='"+b+"' src='"+c+"' />"}return b=b.replace(/(?:\r\n|\r|\n)/g,"<br />"),"<p>"+b+"</p>"}},PREFERRED_TICS:[1,5,10,100,1e3,2e3,5e3,1e4,2e4,3e4,6e4,3e5,6e5,18e5],mediaDuration:0,averageLabelSize:50,init:function(a,b){this.settings=$.extend({debug:!1},b||{}),"undefined"!=typeof fr.ina.amalia.player.log&&"undefined"!=typeof fr.ina.amalia.player.log.LogHandler&&(this.logger=new fr.ina.amalia.player.log.LogHandler({enabled:this.settings.debug})),this.container=a,this.mediaDuration=1e3*this.settings.duration,this.averageLabelSize=50,this.initialize()},initialize:function(){this.container.on("click",{self:this},this.onClick),this.container.draggable({axis:"x"}),this.container.on("drag",{self:this},this.onDrag),this.container.on("dragstop",{self:this},this.onDragStop),$(window).on("resize",{self:this},this.onWindowResize)},getWidth:function(){return Math.round(this.container.width())},getPreferredNbSegments:function(){return Math.round(this.getWidth()/this.averageLabelSize)},createTic:function(a,b,c){var d=$("<div>",{"class":"time-grid","data-tc":a}),e=$("<span>",{"class":"time",text:c,"data-tc":a,title:fr.ina.amalia.player.helpers.UtilitiesHelper.formatTime(a/1e3,25,"ms")});return d.append(e),d.css("left",b+"%"),d},updateSegments:function(a,b){this.currentTcin=a,this.currentTcout=b;var c=b-a,d=this.getPreferredNbSegments(),e=0,f=0,g=a,h=-1;do h++,f=Math.round(c/this.PREFERRED_TICS[h]);while(f>d&&h<this.PREFERRED_TICS.length-1);e=this.PREFERRED_TICS[h],g=Math.max(-1,Math.ceil(a/e)-f)*e,b=Math.min(b+c,this.mediaDuration);var i=0;this.container.empty(),this.container.attr("data-duration",c);do g+=e,i=100*(g-a)/c,this.container.append(this.createTic(g,i,this.getFormatTc(g,e)));while(b>g);this.container.find("span.time").tooltip(this.tooltipConfiguration),null!==this.logger&&this.logger.trace(this.Class.fullName,"updateSegments getWidth() : "+this.getWidth()+" preferredNbSegments :"+d)},getFormatTc:function(a,b){a/=1e3,b/=1e3;var c="",d=Math.floor(a/60),e=Math.floor(d/60),f=Math.floor(a%60),g=a%60;return d=Math.floor(d%60),d=d>=10?d:"0"+d,e=e>=10?e:"0"+e,f=f>=10?f:"0"+f,b>3600?c=0===parseInt(e)?e+"::"+d+":"+f+" m":e+"h":3600>=b&&b>=60?c=0===parseInt(e)?d+":"+f+" m":e+":"+d+" h":60>b&&b>1?c=0!==parseInt(e)&&0===parseInt(d)?g.toFixed(2).toString()+" s":d+":"+f+" m":1>=b&&(c=.001>=b?g.toFixed(4).toString().split(".")[1]+" ms":f+"."+g.toFixed(2).toString().split(".")[1]+" s"),c},onClick:function(a){var b=$(a.target);if(a.preventDefault(),b.hasClass("time")){var c=parseFloat(b.attr("data-tc"));"number"==typeof c&&(a.data.self.container.trigger(a.data.self.Class.eventTypes.CLICK,{tc:c/1e3}),null!==a.data.self.logger&&a.data.self.logger.trace(a.data.self.Class.fullName,"onClick tc:"+c))}},onDrag:function(a,b){var c=$(a.target),d=Math.abs(parseInt(c.find(".time-grid").first().position().left)),e=parseInt(c.find(".time-grid").last().position().left),f=b.position;return b.position.left>d?f.left=d:c.width()-e>b.position.left&&(f.left=c.width()-e),f},onDragStop:function(a,b){var c=$(a.target),d=parseFloat(c.attr("data-tcin")),e=parseFloat(c.attr("data-tcout")),f=e-d,g=Math.abs(b.position.left),h=100*g/c.width(),i=Math.round(f*h/100);d=b.position.left>0?d-i:d+i,e=d+f,"number"==typeof d&&"number"==typeof e&&(c.css("left","0px"),a.data.self.container.trigger(a.data.self.Class.eventTypes.UPDATE_TC,{tcin:d,tcout:Math.min(a.data.self.mediaDuration,e)}),null!==a.data.self.logger&&a.data.self.logger.trace(a.data.self.Class.fullName,"onDragStop tcin:"+d+" tcout"+e))},onWindowResize:function(a){var b=$(a.target).first();b.is("div")===!1&&a.data.self.updateSegments(a.data.self.currentTcin,a.data.self.currentTcout),null!==a.data.self.logger&&a.data.self.logger.trace(a.data.self.Class.fullName,"onWindowResize ")}}),$.Class("fr.ina.amalia.player.plugins.timeline.ZoomComponent",{eventTypes:{CHANGE:"fr.ina.amalia.player.plugins.timeline.ZoomComponent.event.change"}},{logger:null,container:null,settings:{},tcOffset:0,duration:0,currentTcin:0,currentTcout:0,slideSpeed:0,zoomSpeed:2,init:function(a,b,c){this.settings=$.extend({debug:!1,zoomSpeed:10,tcOffset:0},c||{}),"undefined"!=typeof fr.ina.amalia.player.log&&"undefined"!=typeof fr.ina.amalia.player.log.LogHandler&&(this.logger=new fr.ina.amalia.player.log.LogHandler({enabled:this.settings.debug})),this.container=a,this.tcOffset=1e3*parseFloat(this.settings.tcOffset),this.duration=1e3*b,this.zoomSpeed=this.settings.zoomSpeed,this.slideSpeed=0,this.initialize(this.tcOffset,this.duration+this.tcOffset)},initialize:function(a,b){null!==this.logger&&this.logger.trace(this.Class.fullName,"Initialize  tcin"+a+" tcout:"+b+" duration : "+this.duration),this.container.append($("<span>",{"class":"time",style:"display: block; position: absolute;height: 100px;width: 1px;background: aqua;margin-top: -50px;"}));var c=$("<div>",{"class":"list"});this.container.append(c),this.setTc(a,b)},setTc:function(a,b){"number"==typeof a&&"number"==typeof b&&(this.currentTcin=a,this.currentTcout=b,this.updateTime()),null!==this.logger&&this.logger.trace(this.Class.fullName,"setTc / currentTcin :"+this.currentTcin+" currentTcout:"+this.currentTcout)},updateTime:function(){(this.currentTcin<this.tcOffset||this.currentTcout>this.duration)&&(this.currentTcin=this.tcOffset,this.currentTcout=this.duration),this.updateTc(),this.sendEvent(),null!==this.logger&&this.logger.trace(this.Class.fullName,"updateTime currentTcin :"+this.currentTcin+" currentTcout:"+this.currentTcout)},sendEvent:function(){this.container.trigger(this.Class.eventTypes.CHANGE,{tcin:this.currentTcin,tcout:this.currentTcout}),null!==this.logger&&this.logger.trace(this.Class.fullName,"sendEvent sendEvent :"+this.Class.eventTypes.CHANGE+" currentTcin:"+this.currentTcin+" currentTcout "+this.currentTcout)},updateTc:function(){this.container.attr({"data-tcin":this.currentTcin,"data-tcout":this.currentTcout})},zoomIn:function(){var a=this.currentTcout-this.currentTcin,b=Math.round(a/this.zoomSpeed);0!==b&&(this.slideSpeed=b,this.currentTcin+=b,this.currentTcout-=b,this.updateTime())},zoomOut:function(){var a=this.currentTcout-this.currentTcin,b=Math.round(a/this.zoomSpeed);b=0>=b?1:b,this.slideSpeed=b,this.currentTcin-=b,this.currentTcout+=b,this.updateTime()},slideLeft:function(){this.currentTcin-this.slideSpeed>=0&&(this.currentTcin=this.currentTcin-this.slideSpeed,this.currentTcout=this.currentTcout-this.slideSpeed,null!==this.logger&&this.logger.trace(this.Class.fullName,"slideLeft currentZoom : "+this.currentZoom+" currentTcin :"+this.currentTcin+" currentTcout:"+this.currentTcout),this.updateTc(),this.sendEvent())},slideRight:function(){this.currentTcout+this.slideSpeed<=this.duration&&(this.currentTcin=this.currentTcin+this.slideSpeed,this.currentTcout=this.currentTcout+this.slideSpeed,null!==this.logger&&this.logger.trace(this.Class.fullName,"slideRight currentZoom : "+this.currentZoom+" currentTcin :"+this.currentTcin+" currentTcout:"+this.currentTcout),this.updateTc(),this.sendEvent())}}),fr.ina.amalia.player.plugins.timeline.BaseComponent.extend("fr.ina.amalia.player.plugins.timeline.TimeAxisComponent",{eventTypes:{CLICK_AT_TIC:"fr.ina.amalia.player.plugins.timeline.TimeAxisComponent.event.clickattic",RANGE_CHANGE:"fr.ina.amalia.player.plugins.timeline.TimeAxisComponent.event.rangechange",CHANGE_DISPLAY:"fr.ina.amalia.player.plugins.timeline.TimeAxisComponent.event.changedisplay",CHANGE_TIMEAXE_DISPLAY_STATE:"fr.ina.amalia.player.plugins.timeline.TimeAxisComponent.event.changetimeaxedisplaystate"}},{tcin:0,tcout:0,duration:0,segmentsGenerator:null,timeZoomComponent:null,init:function(a){if(this.settings=$.extend({debug:!1,container:null,duration:0,expand:!1,tcOffset:0},a||{}),"undefined"!=typeof fr.ina.amalia.player.log&&"undefined"!=typeof fr.ina.amalia.player.log.LogHandler&&(this.logger=new fr.ina.amalia.player.log.LogHandler({enabled:this.settings.debug})),this.mainContainer=this.settings.container,this.tcin=parseFloat(this.settings.tcOffset),this.tcout=parseFloat(this.settings.duration)+parseFloat(this.settings.tcOffset),this.duration=parseFloat(this.settings.duration),this.segmentsGenerator=null,this.timeZoomComponent=null,0===this.mainContainer.length||"object"!=typeof this.mainContainer)throw new Error("Your container is empty.");this.initialize()},initialize:function(){this.createTimeAxis(),this.settings.expand===!0&&(this.createControleBar(),this.createLabelContainer())},getTcin:function(){return this.tcin},getTcout:function(){return this.tcout},createControleBar:function(){var a=$("<div>",{"class":"toolbar-container"}),b=this.createButton(fr.ina.amalia.player.PlayerMessage.PLUGIN_TIMELINE_LABEL_EXPAND," expand-btn");b.on("click",{self:this},this.onClickExpandBtn),a.append(b),this.mainContainer.append(a)},createLabelContainer:function(){var a=$("<div>",{"class":"timeaxis-label"});a.append($("<p>",{"class":"label",text:fr.ina.amalia.player.PlayerMessage.PLUGIN_TIMELINE_LABEL_TIMEAXE})),this.mainContainer.append(a)},createTimeAxis:function(){var a=$("<div>",{"class":"line-content"}),b=$("<div>",{"class":"line"}),c=$("<div>",{"class":"toolsbar"});this.createToolsBar(c);var d=$("<div>",{"class":"module-timeaxis"});d.append(b),d.append(a),this.mainContainer.append(d),this.mainContainer.append(c),this.segmentsGenerator=new fr.ina.amalia.player.plugins.timeline.TicComponent(a,this.settings),d.on(fr.ina.amalia.player.plugins.timeline.ZoomComponent.eventTypes.CHANGE,{self:this},this.onTimeRangeChange),this.timeZoomComponent=new fr.ina.amalia.player.plugins.timeline.ZoomComponent(a,this.duration,this.settings),this.mainContainer.on("mousewheel",{self:this},this.onMousewheel),this.mainContainer.on("DOMMouseScroll",{self:this},this.onDOMMouseScroll),a.on(fr.ina.amalia.player.plugins.timeline.TicComponent.eventTypes.CLICK,{self:this},this.onClickAtTic),a.on(fr.ina.amalia.player.plugins.timeline.TicComponent.eventTypes.UPDATE_TC,{self:this},this.onUpdateTicRange),null!==this.logger&&this.logger.trace(this.Class.fullName,"createTimeAxis")},createToolsBar:function(a){var b=$("<div>",{"class":"row"}),c=$("<div>",{"class":"col-xs-2 col-md-2 col-lg-2 leftContainer"}),d=$("<div>",{"class":"col-xs-8 col-md-8 col-lg-8 middleContainer"}),e=$("<div>",{"class":"col-xs-2 col-md-2 col-lg-2 rightContainer"}),f=this.createButton(fr.ina.amalia.player.PlayerMessage.PLUGIN_TIMELINE_LABEL_ZOOM_IN,"plus");f.on("click",{self:this},this.onZoomIn),d.append(f);var g=this.createButton(fr.ina.amalia.player.PlayerMessage.PLUGIN_TIMELINE_LABEL_ZOOM_OUT,"minus");g.on("click",{self:this},this.onZoomOut),d.append(g);var h=this.createButton(fr.ina.amalia.player.PlayerMessage.PLUGIN_TIMELINE_LABEL_CHANGE_DISPLAY,"arrows-v");h.on("click",{self:this},this.onChangeDisplay),d.append(h);var i=this.createButton(fr.ina.amalia.player.PlayerMessage.PLUGIN_TIMELINE_LABEL_SLIDE_LEFT,"chevron-left");i.on("click",{self:this},this.onSlideLeft),i.addClass("pull-left"),c.append(i);var j=this.createButton(fr.ina.amalia.player.PlayerMessage.PLUGIN_TIMELINE_LABEL_SLIDE_RIGHT,"chevron-right");j.on("click",{self:this},this.onSlideRight),j.addClass("pull-right"),e.append(j),b.append(c),b.append(d),b.append(e),a.append(b)},setZoomTc:function(a,b){this.timeZoomComponent.setTc(parseFloat(1e3*a),parseFloat(1e3*b))},zoom:function(a){var b="undefined"==typeof a?"in":a;"in"===b?this.timeZoomComponent.zoomIn():this.timeZoomComponent.zoomOut()},slide:function(a){var b="undefined"==typeof a?"left":a;"left"===b?this.timeZoomComponent.slideLeft():this.timeZoomComponent.slideRight()},onTimeRangeChange:function(a,b){a.data.self.segmentsGenerator.updateSegments(b.tcin,b.tcout),a.data.self.mainContainer.trigger(a.data.self.Class.eventTypes.RANGE_CHANGE,{tcin:b.tcin/1e3,tcout:b.tcout/1e3})},onZoomIn:function(a){a.data.self.zoom("in"),null!==a.data.self.logger&&a.data.self.logger.trace(a.data.self.Class.fullName,"onZoomIn")},onZoomOut:function(a){a.data.self.zoom("out"),null!==a.data.self.logger&&a.data.self.logger.trace(a.data.self.Class.fullName,"onZoomOut")},onSlideLeft:function(a){a.data.self.slide("left"),null!==a.data.self.logger&&a.data.self.logger.trace(a.data.self.Class.fullName,"slideLeft")},onSlideRight:function(a){a.data.self.slide("right"),null!==a.data.self.logger&&a.data.self.logger.trace(a.data.self.Class.fullName,"slideRight")},onChangeDisplay:function(a){a.data.self.mainContainer.trigger(a.data.self.Class.eventTypes.CHANGE_DISPLAY),null!==a.data.self.logger&&a.data.self.logger.trace(a.data.self.Class.fullName,"onChangeDisplay")},onDOMMouseScroll:function(a){a.preventDefault();var b=a.originalEvent.wheelDelta?a.originalEvent.wheelDelta:a.originalEvent.detail;"number"==typeof b&&a.data.self.zoom(0>b?"in":"out"),null!==a.data.self.logger&&a.data.self.logger.trace(a.data.self.Class.fullName,"onDOMMouseScroll")},onMousewheel:function(a){a.preventDefault();var b=a.originalEvent.wheelDelta?a.originalEvent.wheelDelta:a.originalEvent.detail;"number"==typeof b&&a.data.self.zoom(b>0?"in":"out"),null!==a.data.self.logger&&a.data.self.logger.trace(a.data.self.Class.fullName,"onMousewheel")},onClickAtTic:function(a,b){b.hasOwnProperty("tc")===!0&&"number"==typeof b.tc&&a.data.self.mainContainer.trigger(a.data.self.Class.eventTypes.CLICK_AT_TIC,{tc:parseFloat(b.tc)})},onUpdateTicRange:function(a,b){b.hasOwnProperty("tcin")===!0&&b.hasOwnProperty("tcout")===!0&&(null!==a.data.self.logger&&a.data.self.logger.trace(a.data.self.Class.fullName,"onUpdateTicRange"),a.data.self.timeZoomComponent.setTc(b.tcin,b.tcout))},onClickExpandBtn:function(a){try{a.data.self.mainContainer.hasClass("off")?(a.data.self.mainContainer.removeClass("off").addClass("on"),a.data.self.mainContainer.trigger(a.data.self.Class.eventTypes.CHANGE_TIMEAXE_DISPLAY_STATE,{state:!0})):(a.data.self.mainContainer.removeClass("on").addClass("off"),a.data.self.mainContainer.trigger(a.data.self.Class.eventTypes.CHANGE_TIMEAXE_DISPLAY_STATE,{state:!1}))}catch(b){null!==a.data.self.logger&&a.data.self.logger.error(a.data.self.Class.fullName+"onClickExpandBtn : "+b.toString())}}}),fr.ina.amalia.player.plugins.timeline.BaseComponent.extend("fr.ina.amalia.player.plugins.timeline.CuepointsComponent",{ComponentClassCss:"cuepoints-component",ComponentModuleClassCss:"module-cuepoints",eventTypes:{CLICK:"fr.ina.amalia.player.plugins.timeline.CuepointsComponent.event.click"}},{initialize:function(){this._super(),this.mainContainer.on("click",".cuepoint",{self:this},this.onClickAtCuepoint)},createCuePointElement:function(a,b,c,d){return $("<i>",{"class":"item cuepoint fa fa-"+this.settings.icon,style:"left: "+b+"%; color:"+this.settings.color+";",title:c,"data-tc":a,"data-tclevel":d})},addItem:function(a){if(a.hasOwnProperty("tc")){var b=parseFloat(a.tc),c=this.tcout-this.tcin,d=100*(b-this.tcin)/c,e=this.mainContainer.find(".line-content").first(),f=a.hasOwnProperty("label")===!0&&""!==a.label&&null!==a.label?a.label:"Tc: "+fr.ina.amalia.player.helpers.UtilitiesHelper.formatTime(b,25,"ms");b>=this.tcin&&b<=this.tcout&&(e.append(this.createCuePointElement(b,d,f,a.tclevel)),null!==this.logger&&this.logger.trace(this.Class.fullName,"addItem tcin: "+this.tcin+" tcout: "+this.tcout+" tc:"+b+" percentPos:"+d))}},removeItems:function(){this.mainContainer.find(".line-content .cuepoint").remove()},onClickAtCuepoint:function(a){var b=$(a.currentTarget),c=parseFloat(b.data("tc"));a.data.self.mainContainer.trigger(a.data.self.Class.eventTypes.CLICK,{tc:c}),null!==a.data.self.logger&&a.data.self.logger.trace(a.data.self.Class.fullName,"onClickAtCuepoint tc:"+c)}}),fr.ina.amalia.player.plugins.timeline.BaseComponent("fr.ina.amalia.player.plugins.timeline.SegmentsComponent",{ComponentClassCss:"segments-component",ComponentModuleClassCss:"module-segments",eventTypes:{CLICK:"fr.ina.amalia.player.plugins.timeline.SegmentsComponent.eventTypes.click",DATA_CHANGE:"fr.ina.amalia.player.plugins.timeline.SegmentsComponent.eventTypes.DATA_CHANGE"}},{initialize:function(){this._super(),this.mainContainer.on("click",".segment",{self:this},this.onClickAtSegment)},createSegmentElement:function(a,b,c,d,e){var f=""!==this.settings.color?"background-color:"+this.settings.color+";":"",g=this.settings.marker===!0?"item segment marker":"item segment",h=$("<div>",{"class":g,style:"left: "+c+"%; width:"+d+"%;"+f,title:e,"data-tc":a,"data-tcin":a,"data-tcout":b});return this.settings.editable===!0&&(h.resizable({handles:"e,w",ghost:!0,helper:"ui-resizable-helper",start:function(a,b){var c=$(a.target).parent(),d=c.width()-b.element.position().left;$(a.target).resizable("option","maxWidth",d)}}),h.on("resizestop",{self:this},this.onResizeStop),h.draggable({axis:"x",drag:function(a,b){var c=$(a.target),d=c.parent(),e=Math.max(0,b.position.left);b.position.left=Math.min(d.first().width()-c.width(),e)}}),h.on("dragstop",{self:this},this.onDragStop),h.css("position","absolute")),h},addItem:function(a){if(a.hasOwnProperty("tcin")&&a.hasOwnProperty("tcout")){var b=parseFloat(a.tcin),c=parseFloat(a.tcout),d=this.tcout-this.tcin,e=100*(c-b)/d,f=100*(b-this.tcin)/d,g=null;g=a.hasOwnProperty("label")===!0&&""!==a.label&&null!==a.label?a.label:"Tc in: "+fr.ina.amalia.player.helpers.UtilitiesHelper.formatTime(b,25,"ms")+"\n Tc out: "+fr.ina.amalia.player.helpers.UtilitiesHelper.formatTime(c,25,"ms");var h=this.mainContainer.find(".line-content").first(),i=null;b<this.tcout&&c>this.tcin&&(i=this.createSegmentElement(b,c,f,e,g),i.data("metadata",a),h.append(i),null!==this.logger&&this.logger.trace(this.Class.fullName,"addItem tcin: "+this.tcin+" tcout: "+this.tcout+" itemTcin:"+b+" itemTcout:"+c+" percentWidth:"+f))}},removeItems:function(){var a=this.mainContainer.find(".line-content").first();a.find(".segment").remove()},onClickAtSegment:function(a){var b=$(a.currentTarget),c=parseFloat(b.data("tcin"));a.data.self.mainContainer.trigger(a.data.self.Class.eventTypes.CLICK,{tc:c}),null!==a.data.self.logger&&a.data.self.logger.trace(a.data.self.Class.fullName,"onClickAtSegment tcin:"+c)},onDragStop:function(a){var b=$(a.currentTarget),c=parseFloat((a.data.self.tcout-a.data.self.tcin)*b.position().left/a.data.self.mainContainer.first().width()),d=c+parseFloat((a.data.self.tcout-a.data.self.tcin)*b.width()/a.data.self.mainContainer.first().width());$(a.currentTarget).data("metadata").tcin=Math.max(0,c),$(a.currentTarget).data("metadata").tcout=Math.min(a.data.self.duration,d),a.data.self.mainContainer.trigger(a.data.self.Class.eventTypes.DATA_CHANGE,{id:a.data.self.getMetadataId()})},onResizeStop:function(a){var b=$(a.currentTarget),c=parseFloat((a.data.self.tcout-a.data.self.tcin)*b.position().left/a.data.self.mainContainer.first().width()),d=c+parseFloat((a.data.self.tcout-a.data.self.tcin)*b.width()/a.data.self.mainContainer.first().width());$(a.currentTarget).data("metadata").tcin=Math.max(0,c),$(a.currentTarget).data("metadata").tcout=Math.min(a.data.self.duration,d),a.data.self.mainContainer.trigger(a.data.self.Class.eventTypes.DATA_CHANGE,{id:a.data.self.getMetadataId()})}}),fr.ina.amalia.player.plugins.timeline.BaseComponent.extend("fr.ina.amalia.player.plugins.timeline.ImagesComponent",{ComponentClassCss:"images-component",ComponentModuleClassCss:"module-images",eventTypes:{CLICK:"fr.ina.amalia.player.plugins.timeline.ImagesComponent.eventTypes.click"}},{tooltipConfiguration:{position:{my:"center bottom-20",at:"center top",delay:3e3,using:function(a,b){$(this).css(a),$("<div>").addClass("inaplayerhtml5-arrow").addClass("timeline-images-component").addClass(b.vertical).addClass(b.horizontal).appendTo(this)}},content:function(){var a=$(this),b=a.attr("title");if(a.is("[data-src]")){var c=a.attr("data-src");return"<img class='timeline-images-component tooltip-image' alt='"+b+"' src='"+c+"' />"}return b=b.replace(/(?:\r\n|\r|\n)/g,"<br />"),"<p>"+b+"</p>"}},initialize:function(){this._super(),this.mainContainer.on("click",".image",{self:this},this.onClickAtImage)},createImageElement:function(a,b,c,d,e,f,g){var h=$("<img>",{src:f,"class":"content",title:e,"data-src":f}).tooltip(this.tooltipConfiguration),i=null;if(null!==b){var j=$("<hr>",{"class":"flow",style:"border-color:"+this.settings.color+"; color:"+this.settings.color+";"});i=$("<div>",{"class":"item image segment",style:"left: "+c+"%; width:"+d+"%;",title:e,"data-tc":a,"data-tclevel":g,"data-tcin":a,"data-tcout":b}).append(j),d>parseInt(this.settings.pointTogglePercentHeight)?i.append(h):i.tooltip(this.tooltipConfiguration)}else i=$("<div>",{"class":"item image",style:"left: "+c+"%; margin-left:-"+this.settings.offset+"px;",title:e,"data-tc":a,"data-tclevel":g}).append(h);return i.on("mouseenter mouseleave",function(a){"mouseenter"===a.type?($(a.currentTarget).parent().find(".image").css("opacity",".3"),$(a.currentTarget).addClass("on").css("opacity","1")):($(a.currentTarget).parent().find(".image").css("opacity","1"),$(a.currentTarget).removeClass("on").css("opacity","1"))}),i},addItem:function(a){var b=null,c=null,d=null,e=this.tcout-this.tcin,f=a.hasOwnProperty("thumb")===!0&&""!==a.thumb&&null!==a.thumb?a.thumb:"";if(a.hasOwnProperty("tcin")&&a.hasOwnProperty("tcout")){var g=parseFloat(a.tcin),h=parseFloat(a.tcout),i=100*(h-g)/e;b=100*(g-this.tcin)/e,c=a.hasOwnProperty("label")===!0&&""!==a.label&&null!==a.label?a.label:"Tc in: "+fr.ina.amalia.player.helpers.UtilitiesHelper.formatTime(g,25,"ms")+"\n Tc out: "+fr.ina.amalia.player.helpers.UtilitiesHelper.formatTime(h,25,"ms"),d=this.mainContainer.find(".line-content").first(),g>=this.tcin&&g<=this.tcout&&(d.append(this.createImageElement(g,h,b,i,c,f,a.tclevel)),null!==this.logger&&this.logger.trace(this.Class.fullName,"addItem tcin: "+this.tcin+" tcout: "+this.tcout+" itemTcin:"+g+" itemTcout:"+h+" percentWidth:"+b))
}else if(a.hasOwnProperty("tc")){var j=parseFloat(a.tc);b=100*(j-this.tcin)/e,c=a.hasOwnProperty("label")===!0&&""!==a.label&&null!==a.label?a.label:fr.ina.amalia.player.helpers.UtilitiesHelper.formatTime(j,25,"ms"),d=this.mainContainer.find(".line-content").first(),j>=this.tcin&&j<=this.tcout&&(d.append(this.createImageElement(j,null,b,null,c,f,a.tclevel)),null!==this.logger&&this.logger.trace(this.Class.fullName,"addItem tc: "+j))}},removeItems:function(){this.mainContainer.find(".line-content").first().find(".image").remove()},onClickAtImage:function(a){var b=$(a.currentTarget),c=parseFloat(b.data("tc"));a.data.self.mainContainer.trigger(a.data.self.Class.eventTypes.CLICK,{tc:c}),null!==a.data.self.logger&&a.data.self.logger.trace(a.data.self.Class.fullName,"onClickAtImage tcin:"+c)}}),fr.ina.amalia.player.plugins.timeline.BaseComponent.extend("fr.ina.amalia.player.plugins.timeline.HistogramComponent",{ComponentClassCss:"histogram-component",ComponentModuleClassCss:"module-histogram",eventTypes:{}},{canvas:null,histogramIsCreated:!1,initialize:function(){this._super(),this.settings=$.extend({mirror:!1},this.settings||{}),this.histogramIsCreated=!1,this.canvas=new Raphael(this.mainContainer.find(".line-content").get(0))},createHistogram:function(a,b,c,d,e){var f=fr.ina.amalia.player.helpers.UtilitiesHelper.base64DecToArr(a,e),g=null,h=parseInt(b);null!==c&&(g=fr.ina.amalia.player.helpers.UtilitiesHelper.base64DecToArr(c,e),h=parseInt(b+d)),this.canvas.setViewBox(0,0,e,h,!1),this.canvas.setSize("100%","100%"),this.canvas.canvas.setAttribute("preserveAspectRatio","none");for(var i=null,j=null,k=0;e>k;k++)i=parseInt(f[k]),this.canvas.path("M"+k+" "+b+"l 0 -"+i).attr({type:"path",stroke:this.settings.color,"stroke-width":"1",fill:this.settings.color}),null!==g&&(j=parseInt(g[k]),this.canvas.path("M"+k+" "+d+"l 0 "+j).attr({type:"path",stroke:this.settings.color,"stroke-width":"1",fill:this.settings.color}));null!==this.logger&&this.logger.trace(this.Class.fullName,"CreateHistogramWithMirror posmax:"+b+"  negmax:"+d+"/ nbbins:"+e)},createHistogramWithMirror:function(a,b,c){var d=fr.ina.amalia.player.helpers.UtilitiesHelper.base64DecToArr(a,c);this.canvas.setViewBox(0,0,c,2*b,!1),this.canvas.setSize("100%","100%"),this.canvas.canvas.setAttribute("preserveAspectRatio","none");for(var e=null,f=0;c>f;f++)e=parseInt(d[f]),this.canvas.path("M"+f+" "+b+"l 0 -"+e).attr({type:"path",stroke:this.settings.color,"stroke-width":"1",fill:this.settings.color}),this.canvas.path("M"+f+" "+b+"l 0 "+e).attr({type:"path",stroke:this.settings.color,"stroke-width":"1",fill:this.settings.color});null!==this.logger&&this.logger.trace(this.Class.fullName,"CreateHistogramWithMirror posmax:"+b+"/ nbbins:"+c)},setZoomTc:function(a,b){if(this._super(a,b),this.settings.zoomable===!0){var c=parseInt(this.settings.tcOffset),d=parseInt(this.settings.duration),e=d-c,f=this.zTcout-this.zTcin,g=100*this.zTcin/e,h=100*e/f;this.mainContainer.find(".line-content").css({left:-g+"%",width:h+"%"})}},addItem:function(a){if(this.histogramIsCreated===!1&&null!==a.data&&a.data.hasOwnProperty("histogram")===!0&&null!==a.data.histogram&&a.data.histogram.length>0){for(var b=0;b<a.data.histogram.length;b++){var c=a.data.histogram[b];if(c.hasOwnProperty("posbins")&&c.hasOwnProperty("negbins")&&c.hasOwnProperty("nbbins")&&c.hasOwnProperty("posmax")&&c.hasOwnProperty("negmax"))try{this.settings.mirror===!0?this.createHistogramWithMirror(c.posbins,c.posmax,c.nbbins):this.createHistogram(c.posbins,c.posmax,c.negbins,c.negmax,c.nbbins)}catch(d){null!==this.logger&&(this.logger.warn("Error to create histogram"),this.logger.warn(d.stack))}else null!==this.logger&&(this.logger.warn(this.Class.fullName+"Error to create histogram"),this.logger.warn(c))}this.histogramIsCreated=!0}},removeItems:function(){}}),fr.ina.amalia.player.plugins.PluginBase.extend("fr.ina.amalia.player.plugins.TimelinePlugin",{classCss:"inaplayerhtml5-plugin plugin-timeline",style:"",componentDefaultHeight:110,eventTypes:{TIME_CHANGE:"fr.ina.amalia.player.plugins.timeline.TIME_CHANGE"}},{timeCursor:null,timeProgressContainer:null,timeAxisComponentContainer:null,timeAxisComponent:null,componentsContainer:null,navBarContainer:null,zoomRangeLevels:null,zoomLevel:0,displayLinesNb:0,listOfComponents:[],tcin:0,tcout:0,zTcin:0,zTcout:0,timeAxeHeight:150,tooltipConfiguration:{position:{my:"center bottom-20",at:"center top",delay:3e3,using:function(a,b){$(this).css(a),$("<div>").addClass("inaplayerhtml5-arrow").addClass(b.vertical).addClass(b.horizontal).appendTo(this)}},content:function(){var a=$(this),b=a.attr("title");if(a.is("[data-src]")){var c=a.attr("data-src");return"<img class='image' alt='"+b+"' src='"+c+"' />"}return b=b.replace(/(?:\r\n|\r|\n)/g,"<br />"),"<p>"+b+"</p>"}},localStorageManager:null,initialize:function(){this.listOfComponents=[],this.settings=$.extend({debug:this.settings.debug,internalPlugin:!1,listOfLines:{},displayLines:3,nbZoomLevel:3,zoomCoef:[.25,1/16,1/64,1/256],zoomProperty:"tclevel",timeaxis:!0,resizable:!1,viewZoomSync:!1,viewZoomSyncOffset:1,timecursor:!0},this.settings.parameters||{}),this.settings.timecursor===!0&&this.createTimeCursor(),this.createTimeProgressContainer(),this.timeAxisComponentContainer=$("<div>",{"class":"timeaxis"}),this.componentsContainer=$("<div>",{"class":"components",style:"height:"+(this.pluginContainer.height()-this.timeAxeHeight)+"px;"}),this.componentsContainer.sortable({handle:".sort-btn"}),this.pluginContainer.append(this.timeAxisComponentContainer),this.pluginContainer.append(this.componentsContainer),this.definePlayerListeners(),this.initializeOnLoadStart()},initializeOnLoadStart:function(){this.tcin=parseFloat(this.mediaPlayer.getTcOffset()),this.tcout=parseFloat(this.mediaPlayer.getDuration()),this.zoomRangeLevels=this.getZoomRangeLevels(this.tcout,this.settings.nbZoomLevel,this.settings.zoomCoef),this.settings.timeaxis===!0?this.initializeTimeAxeComponent():this.timeProgressContainer=null,this.initializeComponents(),this.updateRange(this.tcin,this.tcout),this.localStorageManager=new fr.ina.amalia.player.LocalStorageManager({}),this.pluginContainer.find(".plugin-btn").tooltip("option","disabled",this.localStorageManager.hasItem("help-tooltip")===!1?!1:this.localStorageManager.getItem("help-tooltip")),this.settings.resizable===!0&&this.pluginContainer.resizable({handles:"s",start:this.onResizeStart,resize:this.onResize}),this.pluginContainer.on(fr.ina.amalia.player.plugins.components.FocusComponent.eventTypes.ZOOM_ZONE_CHANGE,{self:this},this.onZoomZoneChangeWithFocusComponent)},definePlayerListeners:function(){var a=this.mediaPlayer.getMediaPlayer();a.on(fr.ina.amalia.player.PlayerEventType.TIME_CHANGE,{self:this},this.onTimeupdate),a.on(fr.ina.amalia.player.PlayerEventType.DATA_CHANGE,{self:this},this.onDataChange),a.on(fr.ina.amalia.player.PlayerEventType.ZOOM_RANGE_CHANGE,{self:this},this.onZoomRangeChange),this.pluginContainer.on(fr.ina.amalia.player.plugins.timeline.SegmentsComponent.eventTypes.DATA_CHANGE,{self:this},this.onSegmentDataChange),null!==this.logger&&this.logger.trace(this.Class.fullName,"definePlayerListeners")},initializeTimeAxeComponent:function(){var a=$.extend({debug:this.settings.debug,container:this.timeAxisComponentContainer,duration:this.mediaPlayer.getDuration(),expand:this.settings.resizable,tcOffset:this.mediaPlayer.getTcOffset()},this.settings.timeAxisSettings||{});try{this.timeAxisComponent=new fr.ina.amalia.player.plugins.timeline.TimeAxisComponent(a),this.timeAxisComponent.getContainer().on(fr.ina.amalia.player.plugins.timeline.TimeAxisComponent.eventTypes.RANGE_CHANGE,{self:this},this.onRangeChange),this.timeAxisComponent.getContainer().on(fr.ina.amalia.player.plugins.timeline.TimeAxisComponent.eventTypes.CHANGE_DISPLAY,{self:this},this.onDisplayStateChange),this.timeAxisComponent.getContainer().on(fr.ina.amalia.player.plugins.timeline.TimeAxisComponent.eventTypes.CHANGE_TIMEAXE_DISPLAY_STATE,{self:this},this.onTimeaxeDisplayStateChange),this.timeAxisComponent.getContainer().on(fr.ina.amalia.player.plugins.timeline.TimeAxisComponent.eventTypes.CLICK_AT_TIC,{self:this},this.onClickTc)}catch(b){null!==this.logger&&this.logger.warn(b),this.timeAxisComponent=null}},initializeComponents:function(){if(this.settings.hasOwnProperty("listOfLines")===!0){for(var a=null,b=null,c=this.settings.listOfLines,d=0;d<c.length;d++){var e=c[d];if(e.hasOwnProperty("title")===!0&&e.hasOwnProperty("type")===!0&&e.hasOwnProperty("metadataId")===!0){switch(a=$("<div>",{"class":"component component_line-"+(d+1)}),this.componentsContainer.append(a),e.type){case"image":b=this.createImagesComponent(a,e);break;case"segment":b=this.createSegmentsComponent(a,e);break;case"histogram":b=this.createHistogramComponent(a,e);break;default:b=this.createCuepointsComponent(a,e)}null!==b?(b.setZoomProperty(this.settings.zoomProperty),this.listOfComponents.push(b)):null!==this.logger&&this.logger.warn("Error initializing the component.")}else null!==this.logger&&this.logger.warn("Error initializing the component.")}this.createTimlineNavBar(c.length)}this.updateComponentsHeight()},createCuepointsComponent:function(container,settings){var componentSettings=$.extend({debug:this.settings.debug,container:container,duration:this.mediaPlayer.getDuration()},settings||{}),cuepointsComponent=null;try{cuepointsComponent=componentSettings.hasOwnProperty("className")===!0?eval("new "+componentSettings.className+"(componentSettings)"):new fr.ina.amalia.player.plugins.timeline.CuepointsComponent(componentSettings),cuepointsComponent.getContainer().on(fr.ina.amalia.player.plugins.timeline.CuepointsComponent.eventTypes.CLICK,{self:this},this.onClickTc),cuepointsComponent.getContainer().on(fr.ina.amalia.player.plugins.timeline.CuepointsComponent.NAV_CLICK,{self:this,component:cuepointsComponent},this.onClickNavControls)}catch(e){null!==this.logger&&this.logger.warn(e)}return cuepointsComponent},createSegmentsComponent:function(container,settings){var componentSettings=$.extend({debug:this.settings.debug,container:container,duration:this.mediaPlayer.getDuration()},settings||{}),segmentsComponent=null;try{segmentsComponent=componentSettings.hasOwnProperty("className")===!0?eval("new "+componentSettings.className+"(componentSettings)"):new fr.ina.amalia.player.plugins.timeline.SegmentsComponent(componentSettings),segmentsComponent.getContainer().on(fr.ina.amalia.player.plugins.timeline.SegmentsComponent.eventTypes.CLICK,{self:this},this.onClickTc),segmentsComponent.getContainer().on(fr.ina.amalia.player.plugins.timeline.CuepointsComponent.NAV_CLICK,{self:this,component:segmentsComponent},this.onClickNavControls)}catch(e){null!==this.logger&&this.logger.warn(e)}return segmentsComponent},createImagesComponent:function(container,settings){var componentSettings=$.extend({debug:this.settings.debug,container:container,duration:this.mediaPlayer.getDuration()},settings||{}),imagesComponent=null;try{imagesComponent=componentSettings.hasOwnProperty("className")===!0?eval("new "+componentSettings.className+"(componentSettings)"):new fr.ina.amalia.player.plugins.timeline.ImagesComponent(componentSettings),imagesComponent.getContainer().on(fr.ina.amalia.player.plugins.timeline.ImagesComponent.eventTypes.CLICK,{self:this},this.onClickTc),imagesComponent.getContainer().on(fr.ina.amalia.player.plugins.timeline.CuepointsComponent.NAV_CLICK,{self:this,component:imagesComponent},this.onClickNavControls)}catch(e){null!==this.logger&&this.logger.warn(e)}return imagesComponent},createHistogramComponent:function(container,settings){var componentSettings=$.extend({debug:this.settings.debug,container:container,duration:this.mediaPlayer.getDuration(),tcOffset:this.mediaPlayer.getTcOffset()},settings||{}),histogramComponent=null;try{histogramComponent=componentSettings.hasOwnProperty("className")===!0?eval("new "+histogramComponent.className+"(componentSettings)"):new fr.ina.amalia.player.plugins.timeline.HistogramComponent(componentSettings)}catch(error){null!==this.logger&&this.logger.warn(error.stack)}return histogramComponent},createTimeCursor:function(){this.timeCursor=$("<div>",{"class":"timeline-cursor"}),this.pluginContainer.append(this.timeCursor),null!==this.logger&&this.logger.trace(this.Class.fullName,"createTimeCursor")},createTimeProgressContainer:function(){this.timeProgressContainer=$("<div>",{"class":"timeline-progress-container"}),this.pluginContainer.append(this.timeProgressContainer),null!==this.logger&&this.logger.trace(this.Class.fullName,"createTimeCursor")},createTimlineNavBar:function(a){this.navBarContainer=$("<div>",{"class":"module-nav-bar-container "});var b=$("<div>",{"class":"row toolsbar"}),c=$("<div>",{"class":"col-xs-3 col-md-3 col-lg-3 leftContainer"}),d=$("<div>",{"class":"col-xs-6 col-md-6 col-lg-6 middleContainer"}),e=$("<div>",{"class":"col-xs-3 col-md-3 col-lg-3 rightContainer"}),f=this.createButton(fr.ina.amalia.player.PlayerMessage.PLUGIN_TIMELINE_LABEL_SCROLL_DOWN,"chevron-down scroll-btn");f.on("click",{self:this},this.onScrollDown);var g=this.createButton(fr.ina.amalia.player.PlayerMessage.PLUGIN_TIMELINE_LABEL_SCROLL_UP,"chevron-up scroll-btn");g.on("click",{self:this},this.onScrollUp),d.append(g),d.append(f),c.append($("<div>",{"class":"info",text:a+" "+fr.ina.amalia.player.PlayerMessage.PLUGIN_TIMELINE_LABEL_ELEMENTS})),e.append(this.createDropdownMenu()),b.append(c),b.append(d),b.append(e),this.navBarContainer.append(b),this.pluginContainer.append(this.navBarContainer),this.pluginContainer.find(".dropdown-toggle").dropdown(),null!==this.logger&&this.logger.trace(this.Class.fullName,"createTimlineNavBar")},createButton:function(a,b){return $("<button>",{title:a,"class":"plugin-btn fa fa-"+b}).tooltip(this.tooltipConfiguration)},createDropdownMenu:function(){var a=$("<div>",{"class":"config-menu btn-group dropup"}),b=$("<span>",{"class":"config-btn dropdown-toggle","data-toggle":"dropdown"});b.append($("<span>",{"class":"fa fa-cog"})),a.append(b);var c=$("<ul>",{"class":"config-menu-list dropdown-menu",role:"menu"}),d=$("<li>",{text:fr.ina.amalia.player.PlayerMessage.PLUGIN_TIMELINE_LABEL_SHOW_HIDE_TOOTIP}).on("click",{self:this},this.onChangeToogleStatus);return c.append(d),a.append(c),a},updateTimelinePos:function(a){var b=parseFloat(a),c=this.tcout-this.tcin,d=100*(b-this.tcin)/c;a>this.tcin&&a<this.tcout?(this.timeCursor.show(),this.timeCursor.data("tc",a),this.timeCursor.css("left",d+"%"),null!==this.timeProgressContainer&&(this.timeProgressContainer.show(),this.timeProgressContainer.data("tc",a),this.timeProgressContainer.css("right",100-d+"%"))):a>this.tcin?(this.timeCursor.hide(),null!==this.timeProgressContainer&&this.timeProgressContainer.css("right","0%")):(this.timeCursor.hide(),null!==this.timeProgressContainer&&this.timeProgressContainer.hide())},updateRange:function(a,b){this.tcin=a,this.tcout=b,this.zoomLevel=this.getZoomRangeLevel(this.tcin,this.tcout),this.updateMetadata(a,b)},updateMetadata:function(a,b){for(var c=null,d=0;d<this.listOfComponents.length;d++){var e=this.listOfComponents[d];e.setZoomLevel(this.zoomLevel),"function"==typeof e.setTcin&&"function"==typeof e.setTcout&&(e.setTcin(a),e.setTcout(b),e.setZoomTc(a,b)),"function"==typeof e.removeItems&&e.removeItems(),"function"==typeof e.addItems&&"function"==typeof e.getMetadataId&&"undefined"!=typeof this.mediaPlayer.getMetadataById(e.getMetadataId())&&(c=this.mediaPlayer.getMetadataById(e.getMetadataId())[0],e.addItems(c))}},updateComponentsHeight:function(){var a=parseFloat(this.pluginContainer.find(".timeaxis").height()+this.pluginContainer.find(".module-nav-bar-container").height()),b=parseFloat(fr.ina.amalia.player.plugins.TimelinePlugin.componentDefaultHeight),c=2;this.displayLinesNb="number"==typeof this.settings.displayLines?this.settings.displayLines:this.settings.listOfLines.length,this.displayLinesNb>this.settings.listOfLines.length&&(this.displayLinesNb=this.settings.listOfLines.length),c=this.displayLinesNb*c,this.settings.timeaxis?this.pluginContainer.css("height",this.displayLinesNb*b+this.timeAxeHeight+this.navBarContainer.height()+"px"):this.pluginContainer.css("height",this.displayLinesNb*b+this.navBarContainer.height()+"px"),this.componentsContainer.css("height",this.pluginContainer.height()-a+"px");var d=this.componentsContainer.height()+c>=this.componentsContainer.get(0).scrollHeight;this.navBarContainer.find(".scroll-btn").toggle(!d),d||this.componentsContainer.on("mousewheel DOMMouseScroll",{self:this},this.onComponentsMousewheel)},updateComponentsLineHeight:function(){var a=this.pluginContainer,b=parseFloat(a.find(".timeaxis").height()+a.find(".module-nav-bar-container").height()),c=2*a.find(".component").length,d=$(a).find(".component").first().height();a.find(".components").first().css("height",d*a.find(".component").length+c),a.css("height",d*a.find(".component").length+c+b)},onChangeToogleStatus:function(a){var b=a.data.self.pluginContainer.find(".plugin-btn").tooltip("option","disabled");a.data.self.pluginContainer.find(".plugin-btn").tooltip("option","disabled",!b),a.data.self.localStorageManager.setItem("help-tooltip",!b)},getZoomRangeLevels:function(a,b,c){for(var d=[],e=null,f=0;b>f;f++)e={level:f,start:b-1>f?c[f]*a:0,end:0===f?a:c[f-1]*a},e.tc=e.end-e.start,d.push(e);return d},getZoomRangeLevel:function(a,b){for(var c=b-a,d=0;d<this.zoomRangeLevels.length;d++)if(c>this.zoomRangeLevels[d].start&&c<this.zoomRangeLevels[d].end)return this.zoomRangeLevels[d].level;return 0},updateZoomChange:function(a,b){(this.zTcin!==a||this.zTcout!==b)&&(this.zTcin=Math.max(0,parseFloat(a)),this.zTcout=Math.min(this.mediaPlayer.getDuration(),parseFloat(b)),this.mediaPlayer.setZoomTc(this.zTcin,this.zTcout,this.eventTag),null!==this.timeAxisComponent&&this.timeAxisComponent.setZoomTc(this.zTcin,this.zTcout),this.updateRange(this.zTcin,this.zTcout),this.settings.timecursor===!0&&this.updateTimelinePos(parseFloat(this.mediaPlayer.getCurrentTime())))},onTimeupdate:function(a,b){if(a.data.self.settings.timecursor===!0&&a.data.self.updateTimelinePos(parseFloat(b.currentTime)),a.data.self.pluginContainer.trigger(fr.ina.amalia.player.plugins.TimelinePlugin.eventTypes.TIME_CHANGE,{currentTime:b.currentTime}),a.data.self.settings.viewZoomSync===!0&&parseFloat(b.currentTime)>a.data.self.zTcout-a.data.self.settings.viewZoomSyncOffset){var c=a.data.self.zTcout-a.data.self.zTcin,d=Math.min(a.data.self.mediaPlayer.getDuration(),a.data.self.zTcout+c),e=Math.max(0,d-c);a.data.self.updateZoomChange(e,d)}},onRangeChange:function(a,b){a.data.self.updateZoomChange(parseFloat(b.tcin),parseFloat(b.tcout)),null!==a.data.self.logger&&a.data.self.logger.trace(a.data.self.Class.fullName,"onRangeChange Tcin:"+b.tcin+" Tcout"+b.tcout)},onClickTc:function(a,b){b.hasOwnProperty("tc")===!0&&a.data.self.mediaPlayer.setCurrentTime(parseFloat(b.tc))},onDisplayStateChange:function(a){for(var b=0;b<a.data.self.listOfComponents.length;b++){var c=a.data.self.listOfComponents[b];"function"==typeof c.changeDisplayState&&c.changeDisplayState()}a.data.self.settings.displayLines===!1&&a.data.self.updateComponentsLineHeight()},onTimeaxeDisplayStateChange:function(a,b){if(null!==a.data.self.timeProgressContainer&&(b.state===!0?a.data.self.timeProgressContainer.css("height","102px"):a.data.self.timeProgressContainer.css("height","2px")),a.data.self.settings.displayLines===!1)a.data.self.updateComponentsLineHeight();else{var c=a.data.self.pluginContainer,d=parseFloat(c.find(".timeaxis").height()+c.find(".module-nav-bar-container").height()),e=2*a.data.self.displayLinesNb,f=$(c).find(".component").first().height(),g=f*a.data.self.displayLinesNb+e;c.find(".components").first().css("height",g),c.css("height",g+d)}},onClickNavControls:function(a,b){if(b.hasOwnProperty("type")===!0){var c="next"===b.type?a.data.component.getNextItem(a.data.self.mediaPlayer.getCurrentTime()):a.data.component.getPrevItem(a.data.self.mediaPlayer.getCurrentTime());a.data.self.mediaPlayer.pause(),null!==c&&a.data.self.mediaPlayer.setCurrentTime(c)}},onScrollUp:function(a){var b=a.data.self.componentsContainer.find(".component").height(),c=a.data.self.componentsContainer.get(0).scrollTop-b;c=Math.min(c,a.data.self.componentsContainer.get(0).scrollHeight),a.data.self.componentsContainer.stop().animate({scrollTop:c},500,"easeInOutExpo")},onScrollDown:function(a){var b=a.data.self.componentsContainer.find(".component").height(),c=a.data.self.componentsContainer.get(0).scrollTop+b;c=Math.min(c,a.data.self.componentsContainer.get(0).scrollHeight),a.data.self.componentsContainer.stop().animate({scrollTop:c},500,"easeInOutExpo")},onComponentsMousewheel:function(a){a.preventDefault();var b=40*Math.max(-1,Math.min(1,a.originalEvent.wheelDelta||-a.originalEvent.detail));if("number"==typeof b){var c=a.data.self.componentsContainer.get(0).scrollTop-b;c=Math.min(c,a.data.self.componentsContainer.get(0).scrollHeight),a.data.self.componentsContainer.get(0).scrollTop=c}},onResizeStart:function(a,b){var c=b.element,d=$(c).find(".component").first().height(),e=2*$(c).find(".component").length,f=parseFloat($(c).find(".timeaxis").height()+$(c).find(".module-nav-bar-container").height());c.resizable("option","minHeight",d+f),c.resizable("option","maxHeight",d*$(c).find(".component").length-e+f)},onResize:function(a,b){var c=b.element,d=parseFloat($(c).find(".timeaxis").height()+$(c).find(".module-nav-bar-container").height());$(c).find(".components").first().css("height",b.size.height-d)},onDataChange:function(a){a.data.self.updateRange(a.data.self.tcin,a.data.self.tcout)},onSegmentDataChange:function(a,b){a.data.self.mediaPlayer.getMediaPlayer().trigger(fr.ina.amalia.player.PlayerEventType.DATA_CHANGE,{id:b.id})},onZoomZoneChangeWithFocusComponent:function(a,b){(Math.ceil(a.data.self.zTcin)!==Math.ceil(b.zTcin)||Math.ceil(a.data.self.zTcout)!==Math.ceil(b.zTcout))&&(a.data.self.updateZoomChange(b.zTcin,b.zTcout),null!==a.data.self.logger&&a.data.self.logger.trace(a.data.self.Class.fullName,"onZoomZoneChangeWithFocusComponent zTcin:"+b.zTcin+" zTcout"+b.zTcout))},onZoomRangeChange:function(a,b){b.eventTag!==a.data.self.eventTag&&(Math.ceil(a.data.self.zTcin)!==Math.ceil(b.zTcin)||Math.ceil(a.data.self.zTcout)!==Math.ceil(b.zTcout))&&(a.data.self.updateZoomChange(b.zTcin,b.zTcout),null!==a.data.self.logger&&a.data.self.logger.trace(a.data.self.Class.fullName,"onZoomRangeChange zTcin:"+b.zTcin+" zTcout"+b.zTcout))}}),$.Class("fr.ina.amalia.player.plugins.textSyncPlugin.Component",{ComponentClassCss:"line-component",eventTypes:{CLICK:"fr.ina.amalia.player.plugins.textSyncPlugin.Component.event.click"}},{settings:{},logger:null,mainContainer:null,tooltipConfiguration:{position:{my:"left+10 center",at:"right center",delay:3e3,using:function(a,b){$(this).css(a),$("<div>").addClass(b.vertical).addClass(b.horizontal).appendTo(this)}}},init:function(a){if(this.settings=$.extend({debug:!1,framerate:"25",container:""},a||{}),"undefined"!=typeof fr.ina.amalia.player.log&&"undefined"!=typeof fr.ina.amalia.player.log.LogHandler&&(this.logger=new fr.ina.amalia.player.log.LogHandler({enabled:this.settings.debug})),this.mainContainer=this.settings.container,0===this.mainContainer.length||"object"!=typeof this.mainContainer)throw new Error("Your container is empty.");this.initialize()},initialize:function(){null!==this.logger&&this.logger.trace(this.Class.fullName,"initialize"),this.mainContainer.addClass(this.Class.ComponentClassCss)},createLine:function(a,b,c,d,e){var f=$("<li>",{"class":"line media","data-tcin":a,"data-tcout":b}),g=$("<div>",{"class":"info pull-left"});e=null===e?"":'background-image:url("'+e+'");';var h=$("<div>",{"class":"thumb","data-tc":a,style:e});g.append(h),h.on("click",{self:this},this.onClickAtTc);var i=$("<time>",{"class":"tcin badge",title:"Tc in","data-tc":a,text:fr.ina.amalia.player.helpers.UtilitiesHelper.formatTime(a,this.settings.framerate,"s")}).tooltip(this.tooltipConfiguration).on("click",{self:this},this.onClickAtTc),j=$("<time>",{"class":"tcout badge",title:"Tc out","data-tc":b,text:fr.ina.amalia.player.helpers.UtilitiesHelper.formatTime(b,this.settings.framerate,"s")}).tooltip(this.tooltipConfiguration).on("click",{self:this},this.onClickAtTc),k=$("<div>",{"class":"progress"}).hide(),l=$("<div>",{"class":"progress-bar",style:"width:0%;"});k.append(l),g.append(i),g.append(j);var m=$("<div>",{"class":"content"});if(null!==c){var n=$("<label>",{"class":"media-heading",text:c});m.append(n)}this.textContainer=$("<p>",{"class":"text"}),"string"==typeof d?this.textContainer.html(d):this.textContainer.append(d),m.append(this.textContainer),m.append(k),f.append(g),f.append(m),this.mainContainer.append(f)},addText:function(a){null!==this.textContainer&&this.textContainer.append(a)},onClickAtTc:function(a){var b=$(a.currentTarget),c=parseFloat(b.attr("data-tc"));a.data.self.mainContainer.trigger(a.data.self.Class.eventTypes.CLICK,{tc:c}),null!==a.data.self.logger&&a.data.self.logger.trace(a.data.self.Class.fullName,"onClickAtCuepoint tc:"+c)}}),fr.ina.amalia.player.plugins.captions.CaptionsBase.extend("fr.ina.amalia.player.plugins.TextSyncPlugin",{classCss:"inaplayerhtml5-plugin plugin-text-sync",style:""},{listOfComponents:[],withMainLevel:!1,karaoke:!1,initialize:function(){this.container=$("<ul>",{"class":"media-list"}),this.listOfComponents=[],this.listOfData=[],this.definePlayerListeners(),this.settings=$.extend({debug:this.settings.debug,framerate:"25",internalPlugin:!1,metadataId:"",level:2,title:"",description:"",displayLevel:""},this.settings.parameters||{}),this.settings.displayLevel=""===this.settings.displayLevel?this.settings.level:this.settings.displayLevel,this.withMainLevel=this.settings.displayLevel!==this.settings.level,this.karaoke=this.withMainLevel,this.updateMetadata(this.settings.metadataId,this.settings.level,0,this.mediaPlayer.getDuration(),!0),""!==this.settings.title&&this.createTitleBlock(this.settings.title,this.settings.description),this.initializeComponents(this.settings.displayLevel),this.container.on(fr.ina.amalia.player.plugins.textSyncPlugin.Component.eventTypes.CLICK,{self:this},this.onClickTc),this.pluginContainer.append(this.container)},initializeComponents:function(a){for(var b=null,c=null,d=0;d<this.listOfData.length;d++)c=this.listOfData[d],c.level===a?(b=this.createComponent(this.container),null!==b?("function"==typeof b.createLine&&b.createLine(c.tcin,c.tcout,c.label,this.withMainLevel===!0?"":c.text,c.thumb),this.listOfComponents.push(b)):null!==this.logger&&this.logger.warn("Error initializing the component.")):null!==b&&b.addText(this.createWord(c));this.container.height(parseInt(this.pluginContainer.height()-parseInt(this.pluginContainer.find(".media.header").first().height()))+"px")},createWord:function(a){return $("<span>",{"class":"word",text:a.text,"data-tcin":a.tcin,"data-tcout":a.tcout})},createComponent:function(a,b){var c=null,d=$.extend({debug:this.settings.debug,container:a},b||{});try{c=new fr.ina.amalia.player.plugins.textSyncPlugin.Component(d)}catch(e){null!==this.logger&&this.logger.warn(e)}return c},updatePos:function(a){a=parseFloat(a),this.container.find(".line").removeClass("on"),this.container.find(".line").filter(function(b,c){return a>=Math.round(parseFloat($(c).attr("data-tcin")))&&a<Math.round(parseFloat($(c).attr("data-tcout")))}).addClass("on").each(function(b,c){c=$(c);var d=0,e=Math.round(parseInt($(c).attr("data-tcin"))),f=Math.round(parseInt($(c).attr("data-tcout")));d=100*(Math.round(a)-e)/(f-e),c.find(".progress").show(),c.find(".progress-bar").css("width",Math.round(d)+"%")}),this.karaoke===!0&&(this.container.find(".word").removeClass("on"),this.container.find(".word").filter(function(b,c){return a>=parseFloat($(c).attr("data-tcin"))&&a<parseFloat($(c).attr("data-tcout"))}).addClass("on"))},createTitleBlock:function(a,b){var c=$("<div>",{"class":"media header"}),d=$("<div>",{"class":"media-body resume"}),e=$("<h3>",{"class":"media-heading",text:a});d.append(e);var f=$("<p>",{text:b});d.append(f),c.append(d),this.pluginContainer.append(c)},onClickTc:function(a,b){b.hasOwnProperty("tc")===!0&&b.tc!==!0&&a.data.self.mediaPlayer.setCurrentTime(parseFloat(b.tc))},definePlayerListeners:function(){var a=this.mediaPlayer.getMediaPlayer();a.on(fr.ina.amalia.player.PlayerEventType.TIME_CHANGE,{self:this},this.onTimeupdate),a.on(fr.ina.amalia.player.PlayerEventType.SEEK,{self:this},this.onSeek)},onSeek:function(a,b){var c=parseFloat(b.currentTime),d=a.data.self.container.find("li.line").eq(0).position(),e=a.data.self.container.find("li.line").filter(function(a,b){return c>=Math.round(parseFloat($(b).attr("data-tcin")))&&c<Math.round(parseFloat($(b).attr("data-tcout")))}).first().position();e&&d&&a.data.self.container.stop().animate({scrollTop:e.top-d.top},1500,"easeInOutExpo")}}),fr.ina.amalia.player.plugins.captions.CaptionsBase.extend("fr.ina.amalia.player.plugins.CaptionsPlugin",{classCss:"inaplayerhtml5-plugin plugin-caption",classCssFullscreenOn:"fullScreenOn",classCssFullscreenOff:"fullScreenOff"},{initialize:function(){this.container=$("<div>",{"class":this.Class.classCss}),this.container.addClass(this.Class.classCssFullscreenOff),this.listOfData=[],this.definePlayerListeners()},definePlayerListeners:function(){var a=this.mediaPlayer.getMediaPlayer();a.on(fr.ina.amalia.player.PlayerEventType.PLUGIN_READY,{self:this},this.onPluginReady),a.on(fr.ina.amalia.player.PlayerEventType.TIME_CHANGE,{self:this},this.onTimeupdate),a.on(fr.ina.amalia.player.PlayerEventType.FULLSCREEN_CHANGE,{self:this},this.onFullscreenModeChange),null!==this.logger&&this.logger.trace(this.Class.fullName,"definePlayerListeners")},onPluginReady:function(a){a.data.self.initializeOnLoadStart()},initializeOnLoadStart:function(){this.settings=$.extend({debug:this.settings.debug,framerate:"25",internalPlugin:!1,metadataId:"",level:2},this.settings.parameters||{}),this.updateMetadata(this.settings.metadataId,this.settings.level,0,this.mediaPlayer.getDuration()),this.pluginContainer.append(this.container)},updatePos:function(a){a=parseFloat(a);for(var b=$.grep(this.listOfData,function(b){return a>=parseFloat(b.tcin)&&a<parseFloat(b.tcout)}),c="",d=null,e=0;e<b.length;e++)d=b[e],null!==d&&"undefined"!=typeof d&&d.hasOwnProperty("text")===!0&&(c+=d.text.toString());""!==c?(this.container.html(c),this.container.show()):(this.container.html(""),this.container.hide())},setFullscreenMode:function(a){a===!0?this.container.removeClass(this.Class.classCssFullscreenOff).addClass(this.Class.classCssFullscreenOn):this.container.removeClass(this.Class.classCssFullscreenOn).addClass(this.Class.classCssFullscreenOff)},onFullscreenModeChange:function(a,b){a.data.self.setFullscreenMode(b.inFullScreen)}}),$.Class("fr.ina.amalia.player.plugins.overlay.SpatialsDataParser",{},{data:null,spatials:null,settings:{},logger:null,init:function(a,b){this.data=b,this.spatials=[],this.settings=$.extend({debug:!1},a||{}),"undefined"!=typeof fr.ina.amalia.player.log&&"undefined"!=typeof fr.ina.amalia.player.log.LogHandler&&(this.logger=new fr.ina.amalia.player.log.LogHandler({enabled:this.settings.debug})),null!==this.data&&this.initialize()},initialize:function(){null!==this.logger&&this.logger.trace(this.Class.fullName,"initialize"),this.parserMetadata()},parserMetadata:function(){for(var a=null,b=0;b<this.data.length;b++)a=this.data[b],a.hasOwnProperty("spatials")&&null!==a.spatials&&this.parserSpatials(a);null!==this.logger&&(this.logger.trace(this.Class.fullName,"parserMetadata"),this.logger.info(this.data))},parserSpatials:function(a){var b=a.spatials,c=null,d=null,e=null;if(b.hasOwnProperty("spatial")&&"object"==typeof b.spatial){e=b.spatial;for(var f=0;f<e.length;f++)null===c?c=e[f]:(d=e[f],this.addSpatial(c,d,a),c=e[f])}},addSpatial:function(a,b,c){"object"==typeof a&&"object"==typeof b&&a.hasOwnProperty("tc")&&b.hasOwnProperty("tc")?this.spatials.push({start:a,end:b,type:this.getType(a),data:c.data,label:c.label,thumb:c.thumb,tcin:fr.ina.amalia.player.helpers.UtilitiesHelper.convertHourToSeconde(a.tc),tcout:fr.ina.amalia.player.helpers.UtilitiesHelper.convertHourToSeconde(b.tc)}):null!==this.logger&&(this.logger.warn(this.Class.fullName+": Error to add spatial"),this.logger.warn([a,b]))
},getType:function(a){return a.hasOwnProperty("point")&&null!==a.point?"point":a.hasOwnProperty("ellipse")&&null!==a.ellipse?"ellipse":"rect"},getData:function(){return $.extend(!0,[],this.spatials)}}),$.Class("fr.ina.amalia.player.plugins.overlay.DrawBase",{classCss:"draw-base",eventTypes:{CLICK:"fr.ina.amalia.player.plugins.overlay.DrawBase.eventTypes.CLICK"}},{settings:{},logger:null,container:null,mediaPlayer:null,element:null,labelElement:null,data:null,init:function(a,b,c){if(this.mediaPlayer=b,this.data=c,this.settings=$.extend({debug:!1,container:null,canvas:null,demo:!1,style:{fill:"#00CCFF",strokeWidth:1,stroke:"#000",fillOpacity:0,strokeDasharray:"- "}},a||{}),this.container=this.settings.container,"undefined"!=typeof fr.ina.amalia.player.log&&"undefined"!=typeof fr.ina.amalia.player.log.LogHandler&&(this.logger=new fr.ina.amalia.player.log.LogHandler({enabled:this.settings.debug})),"object"==typeof this.settings.canvas&&null!==this.data&&this.initialize(),null!==this.mediaPlayer){var d=this.mediaPlayer.getMediaPlayer();d.on(fr.ina.amalia.player.PlayerEventType.PLAYING,{self:this},this.onPlay),d.on(fr.ina.amalia.player.PlayerEventType.PAUSED,{self:this},this.onPause)}},initialize:function(){null!==this.logger&&(this.logger.trace(this.Class.fullName,"initialize"),this.logger.info(this.data))},getStyle:function(){return{fill:this.settings.style.fill,stroke:this.settings.style.stroke,"stroke-width":this.settings.style.strokeWidth,"fill-opacity":this.settings.style.fillOpacity,"stroke-dasharray":this.settings.style.strokeDasharray}},onClick:function(a){null!==a.data.self.container&&a.data.self.container.trigger(fr.ina.amalia.player.plugins.overlay.DrawBase.eventTypes.CLICK,{tcin:a.data.tcin,tcout:a.data.tcout,data:a.data.data})},onPlay:function(a){null!==a.data.self.element&&a.data.self.element.resume()},onPause:function(a){null!==a.data.self.element&&a.data.self.element.pause()},onEndOfAnimation:function(){this.data("demo")!==!0&&this.remove()}}),fr.ina.amalia.player.plugins.overlay.DrawBase.extend("fr.ina.amalia.player.plugins.overlay.DrawRect",{classCss:"spatial-base"},{initialize:function(){if(this.data.hasOwnProperty("tcin")&&this.data.hasOwnProperty("tcout")&&this.data.hasOwnProperty("start")&&this.data.hasOwnProperty("end")){var a=this.getStyle(),b=this.getRectData(this.data.start),c=this.getRectData(this.data.end),d=parseFloat(this.data.tcout-this.data.tcin),e=this.data.hasOwnProperty("label")?this.data.label:"";if(null!==b&&null!==c){if(this.element=this.settings.canvas.rect(b.x,b.y,b.w,b.h),this.element.attr(a),this.element.transform("r"+Math.round(b.o/Math.PI*180)),this.element.attr({cursor:"pointer"}),this.element.data("demo",this.settings.demo),this.settings.labels===!0&&""!==e&&(this.labelElement=this.settings.canvas.text(b.x+b.w/2,b.y+b.h/2,e).attr({font:"12px Arial",opacity:1,fill:"#000"})),null!==this.mediaPlayer&&!this.mediaPlayer.isPaused()){var f={x:c.x,y:c.y,width:c.w,height:c.h,transform:"r"+Math.round(c.o/Math.PI*180)};if(this.element.stop().animate(f,1e3*d,"",this.onEndOfAnimation),null!==this.labelElement){var g={x:c.x+c.w/2,y:c.y+c.y/2};this.labelElement.stop().animate(g,1e3*d,"",this.onEndOfAnimation)}}return $(this.element.node).on("click",{self:this,data:this.data,tcin:this.data.tcin,tcout:this.data.tcout},this.onClick),null!==this.logger&&(this.logger.trace(this.Class.fullName,"initialize"),this.logger.info({data:this.data,start:b,end:c})),!0}}null!==this.logger&&(this.logger.error("Error :"+this.Class.fullName+":initialize"),this.logger.error(this.data))},getRectData:function(a){var b={x:0,y:0,width:0,height:0,r:0,o:0};try{var c=this.settings.canvas.width,d=this.settings.canvas.height;if(a.hasOwnProperty("rect"))return b.x=a.rect.x*c,b.y=a.rect.y*d,b.w=a.rect.w*c,b.h=a.rect.h*d,b.o=a.rect.o,b}catch(e){null!==this.logger&&(this.logger.error("Error to parse data GetRectData "),this.logger.error(a))}return null}}),fr.ina.amalia.player.plugins.overlay.DrawBase.extend("fr.ina.amalia.player.plugins.overlay.DrawEllipse",{classCss:"spatial-ellipse"},{initialize:function(){if(this.data.hasOwnProperty("tcin")&&this.data.hasOwnProperty("tcout")&&this.data.hasOwnProperty("start")&&this.data.hasOwnProperty("end")){var a=this.getStyle(),b=this.getEllipseData(this.data.start),c=this.getEllipseData(this.data.end),d=parseFloat(this.data.tcout-this.data.tcin),e=this.data.hasOwnProperty("label")?this.data.label:"";if(null!==b&&null!==c){if(this.element=this.settings.canvas.ellipse(b.cx,b.cy,b.rx,b.ry),this.element.attr(a),this.element.transform("r"+Math.round(b.o/Math.PI*180)),this.element.attr({cursor:"pointer"}),this.settings.labels===!0&&""!==e&&(this.labelElement=this.settings.canvas.text(b.cx,b.cy,e).attr({font:"12px Arial",opacity:1,fill:"#000"})),null!==this.mediaPlayer&&!this.mediaPlayer.isPaused()){var f={cx:c.cx,cy:c.cy,rx:c.rx,ry:c.ry,transform:"r"+Math.round(c.o/Math.PI*180)};if(this.element.stop().animate(f,1e3*d,"",this.onEndOfAnimation),null!==this.labelElement){var g={x:c.cx,y:c.cy};this.labelElement.stop().animate(g,1e3*d,"",this.onEndOfAnimation)}}return $(this.element.node).on("click",{self:this,data:this.data,tcin:this.data.tcin,tcout:this.data.tcout},this.onClick),null!==this.logger&&(this.logger.trace(this.Class.fullName,"initialize"),this.logger.info({data:this.data,start:b,end:c})),!0}}null!==this.logger&&(this.logger.error("Error :"+this.Class.fullName+":initialize"),this.logger.error(this.data))},getEllipseData:function(a){var b={x:0,y:0,rx:0,ry:0,o:0};try{var c=this.settings.canvas.width,d=this.settings.canvas.height;if(a.hasOwnProperty("ellipse"))return b.cx=a.ellipse.xc*c,b.cy=a.ellipse.yc*d,b.rx=a.ellipse.hw*c,b.ry=a.ellipse.hh*d,b.o=a.ellipse.o,b}catch(e){null!==this.logger&&(this.logger.error("Error to parse data getEllipseData"),this.logger.error(a))}return null}}),fr.ina.amalia.player.plugins.PluginBase.extend("fr.ina.amalia.player.plugins.OverlayPlugin",{classCss:"inaplayerhtml5-plugin plugin-overlay",eventTypes:{CLICK:"fr.ina.amalia.player.plugins.OverlayPlugin.eventTypes.CLICK"}},{spatialsDataParser:null,spatialsData:null,container:null,canvas:null,initialize:function(){this.settings=$.extend({offsetTime:1,callbacks:{}},this.settings||{}),this.container=$("<div>",{"class":this.Class.classCss}),this.pluginContainer.append(this.container),this.canvas=null,this.spatialsData=null,this.definePlayerListeners()},initializeOnLoadStart:function(){this.updateMetadata(this.settings.metadataId,0,this.mediaPlayer.getDuration()),this.pluginContainer.append(this.container),this.createCanvas(),this.createContextMenuOption()},definePlayerListeners:function(){var a=this.mediaPlayer.getMediaPlayer();a.one(fr.ina.amalia.player.PlayerEventType.PLUGIN_READY,{self:this},this.onFirstTimechange),a.on(fr.ina.amalia.player.PlayerEventType.ENDEN,{self:this},this.onEnd),a.on(fr.ina.amalia.player.PlayerEventType.TIME_CHANGE,{self:this},this.onTimeupdate),a.on(fr.ina.amalia.player.PlayerEventType.SEEK,{self:this},this.onSeek),$(window).on("resize",{self:this},this.onWindowResize),null!==this.logger&&this.logger.trace(this.Class.fullName,"definePlayerListeners")},createContextMenuOption:function(){var a=this.mediaPlayer.addMenuItemWithLink(fr.ina.amalia.player.PlayerMessage.PLUGIN_OVERLAY_CONTEXT_MENU_ENABLED_DISABLED_PLUGIN,"#","presentation");"object"==typeof a&&$(a).on("click",{self:this},function(a){a.preventDefault(),a.data.self.changeDisplayState()})},changeDisplayState:function(){this.container.is(":visible")?this.container.hide():this.container.show()},updateMetadata:function(a,b,c){var d=this.mediaPlayer.getMetadataWithRange(a,b,c);this.spatialsDataParser=new fr.ina.amalia.player.plugins.overlay.SpatialsDataParser(this.settings,d),this.spatialsData=this.spatialsDataParser.getData(),null!==this.logger&&(this.logger.trace(this.Class.fullName,"updateMetadata metadataId: "+a+" tcin :"+b+" tcout:"+c),this.logger.info(this.spatialsData))},updatePos:function(a){if("undefined"!=typeof this.spatialsData&&null!==this.spatialsData&&"object"==typeof this.spatialsData&&this.spatialsData.length>0){a=parseFloat(a);var b=this.getDisplayItems(a);b.length>0&&this.createObject(b)}},getDisplayItems:function(a){for(var b=null,c=this.spatialsData,d=[],e=0;e<this.spatialsData.length;e++)b=this.spatialsData[e],"object"==typeof b&&b.hasOwnProperty("tcin")&&a>=parseFloat(b.tcin)&&a<=parseFloat(b.tcin)+this.settings.offsetTime&&(d.push(b),c.splice(e,1));return this.spatialsData=c,d},createCanvas:function(){var a=this.getVideoSize(),b=a.w,c=a.h;this.canvas=new Raphael(this.container.get(0),b,c),this.canvas.canvas.className.baseVal="overlay-canvas",this.updateCanvasPosition(),this.container.on(fr.ina.amalia.player.plugins.overlay.DrawBase.eventTypes.CLICK,{self:this},this.onClickAtObject),null!==this.logger&&this.logger.trace(this.Class.fullName,"CreateCanvas width:"+b+" height: "+c)},getVideoSize:function(){var a=this.mediaPlayer.getMediaPlayer(),b=a.get(0).videoHeight,c=a.get(0).videoWidth,d=a.width()/c,e=a.height()/b,f=Math.min(d,e);return{w:f*c,h:f*b}},updateCanvasPosition:function(){var a=this.getVideoSize();this.container.find(".overlay-canvas").css({left:(this.container.width()-a.w)/2,top:(this.container.height()-a.h)/2})},createObject:function(a){if(null!==a&&"undefined"!=typeof a){var b=$.extend({canvas:this.canvas,container:this.container,debug:this.settings.debug},this.settings.parameters||{}),c=null,d=null;if("object"==typeof a&&a.length>0)for(var e=0;e<a.length;++e)c=a[e],c.hasOwnProperty("type")&&("rect"===c.type?d=new fr.ina.amalia.player.plugins.overlay.DrawRect(b,this.mediaPlayer,a[e]):"ellipse"===c.type?d=new fr.ina.amalia.player.plugins.overlay.DrawEllipse(b,this.mediaPlayer,a[e]):null!==this.logger&&this.logger.warn(this.Class.fullName+": L'objet ne peut pas être interpreté."))}else this.logger.error("Error to create object"),this.logger.error(a)},clearCanvas:function(){this.canvas.clear(),this.spatialsData=this.spatialsDataParser.getData(),null!==this.logger&&this.logger.trace(this.Class.fullName,"clearCanvas : "+this.spatialsData.length)},onWindowResize:function(a){var b=a.data.self.getVideoSize(),c=b.w,d=b.h;null!==this.canvas&&(a.data.self.clearCanvas(),a.data.self.canvas.setSize(c,d),a.data.self.updateCanvasPosition()),null!==a.data.self.logger&&a.data.self.logger.trace(a.data.self.Class.fullName,"onWindowResize W: "+c+" H:"+d)},onFirstTimechange:function(a){a.data.self.initializeOnLoadStart(),null!==a.data.self.logger&&a.data.self.logger.trace(a.data.self.Class.fullName,"timechange")},onEnd:function(a){a.data.self.clearCanvas()},onTimeupdate:function(a,b){a.data.self.updatePos(parseFloat(b.currentTime))},onSeek:function(a){a.data.self.clearCanvas()},onClickAtObject:function(event,data){if("undefined"!=typeof event.data.self.settings.parameters.callbacks.click)try{eval(event.data.self.settings.parameters.callbacks.click+"(data)")}catch(e){null!==event.data.self.logger&&event.data.self.logger.warn("Send callback failed.")}null!==event.data.self.logger&&(event.data.self.logger.info(event.data.self.Class.fullName,"onClickAtObject"),event.data.self.logger.warn(event.data),event.data.self.logger.warn(data))}}),fr.ina.amalia.player.plugins.PluginBase.extend("fr.ina.amalia.player.plugins.WatermarkPlugin",{classCss:"inaplayerhtml5-plugin plugin-watermark",eventTypes:{}},{container:null,ratio:0,placement:"",placementList:["c","tl","tr","bl","br"],initialize:function(){this._super(),this.settings=$.extend({backgroundImageUrl:"",ratio:50,placement:"c",imageWidth:0,imageHeight:0},this.settings.parameters||{}),this.setPlacement(this.settings.placement),this.container=$("<div>",{"class":this.Class.classCss}),this.pluginContainer.append(this.container),this.defineListeners()},defineListeners:function(){var a=this.mediaPlayer.getMediaPlayer();a.one(fr.ina.amalia.player.PlayerEventType.TIME_CHANGE,{self:this},this.onPluginReady),$(window).on("resize",{self:this},this.onWindowResize),null!==this.logger&&this.logger.trace(this.Class.fullName,"definePlayerListeners")},initializeOnLoadStart:function(){this.createWatermarkElement()},createWatermarkElement:function(){var a=$("<div>",{style:"background-image: url("+this.settings.backgroundImageUrl+");","class":"watermark"});this.container.append(a),this.updatePos()},updatePos:function(){var a=this.getVideoSize(),b=a.w,c=a.h,d=(this.container.width()-b)/2,e=(this.container.height()-c)/2;this.container.find(".watermark").css({width:b+"px",height:c+"px",top:e+"px",left:d+"px"}),this.updateImagePositionWithPlacement(),this.updateImageSize()},updateImageSize:function(){var a=this.getVideoSize(),b=a.w/this.settings.imageWidth,c=a.h/this.settings.imageHeight,d=Math.min(b,c);d*=this.settings.ratio/100;var e=d*this.settings.imageWidth,f=d*this.settings.imageHeight,g=this.container.find(".watermark");g.css("background-size",e+"px "+f+"px")},updateImagePositionWithPlacement:function(){var a=this.container.find(".watermark"),b="50%",c="50%";"tl"===this.placement?(b="0%",c="0%"):"tr"===this.placement?(b="100%",c="0%"):"bl"===this.placement?(b="0%",c="100%"):"br"===this.placement&&(b="100%",c="100%"),a.css("background-position",b+" "+c)},getVideoSize:function(){var a=this.mediaPlayer.getMediaPlayer(),b=a.get(0).videoHeight,c=a.get(0).videoWidth;0===b&&(b=a.height()),0===c&&(c=a.width());var d=a.width()/c,e=a.height()/b,f=Math.min(d,e);return{w:f*c,h:f*b}},getPosition:function(){return this.placement},setPlacement:function(a){this.placement=-1===$.inArray(a,this.placementList)?this.placementList[0].toString():a.toString()},onPluginReady:function(a){a.data.self.initializeOnLoadStart()},onWindowResize:function(a){a.data.self.updatePos()}});